package pwc.taxtech.atms.controller;

import com.github.pagehelper.PageInfo;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.dao.PwcTagMapper;
import pwc.taxtech.atms.dpo.InteractionalLinkDto;
import pwc.taxtech.atms.dpo.TaxEmailDto;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.entity.*;
import pwc.taxtech.atms.service.impl.InteractionLinkServiceImpl;
import pwc.taxtech.atms.service.impl.TaxEamilServiceImpl;

import java.io.IOException;
import java.util.List;


/**
 * 税享,第一版 命名taxemail 其他的是Interaction 开头的
 * 2019-05-22 20:51
 *
 * @author: sam
 **/
@RestController
@RequestMapping("/api/v1/Link")
public class InteractionLinkController {

    @Autowired
    InteractionLinkServiceImpl interactionLinkService;


    /**
     * admin审核部分的查询
     *
     * @param interactionalLinkDto
     * @return
     */
    @RequestMapping(value = "listAdmin", method = RequestMethod.GET)
    @ResponseBody
    public List<InteractionalLinkDto> selectTaxAdminEmailList(InteractionalLinkDto interactionalLinkDto) {
        return interactionLinkService.listAdminLink(interactionalLinkDto);
    }


    /**
     * 用户列表部分的查询
     *
     * @param interactionalLinkDto
     * @return
     */
    @RequestMapping(value = "list", method = RequestMethod.GET)
    @ResponseBody
    public List<InteractionalLinkDto> selectTaxEmailList(InteractionalLinkDto interactionalLinkDto) {
        return interactionLinkService.listLink(interactionalLinkDto);
    }

    /**
     * 用户列表部分的查询
     *
     * @param id
     * @return
     */
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    @ResponseBody
    public ApiResultDto selectTaxEmailList(@PathVariable String id) {
        return ApiResultDto.success(interactionLinkService.getLinkById(id));
    }


    /**
     * @param interactionalLink
     * @return
     */
    @RequestMapping(value = "add", method = RequestMethod.POST)
    @ResponseBody
    public ApiResultDto addLink(@RequestBody InteractionalLink interactionalLink) {
        interactionLinkService.insert(interactionalLink);
        return ApiResultDto.success();
    }

    /**
     * @param interactionalLink
     * @return
     */
    @RequestMapping(value = "edit", method = RequestMethod.POST)
    @ResponseBody
    public ApiResultDto editLink(@RequestBody InteractionalLink interactionalLink) {
        interactionLinkService.edit(interactionalLink);
        return ApiResultDto.success();
    }

    @RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
    @ResponseBody
    public ApiResultDto deleteLink(@PathVariable String id) {
        interactionLinkService.delete(id);
        return ApiResultDto.success();
    }


}
