package pwc.taxtech.atms.dto.backlogManage;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;
import pwc.taxtech.atms.constant.enums.BackLogEnum;
import pwc.taxtech.atms.dto.didiFileUpload.DidiFileUploadDetailResult;
import pwc.taxtech.atms.dto.reportFileUpload.ReportFileUploadResult;
import pwc.taxtech.atms.vat.entity.FileUpload;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

public class BacklogDetailResult implements Serializable {


    private static final long serialVersionUID = 2392342095306800544L;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long id;

    private String orgName;

    private String businessLine;

    private String backlogName;

    private String backlogStatus;

    private Date backlogStartDate;

    private Date backlogEndDate;

    private Date chinaBacklogStartDate;

    private Date chinaBacklogEndDate;

    private String dealUser;

    private String auditUser;

    private String createUser;

    private String currentUser;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long backlogTypeId;

    private Integer backlogGenerateType;

    private Integer outTimeFlag;

    private String backlogCode;

    private String backlogGroupCode;

    private boolean backlogAutoFlag;

    private String backlogDescribe;

    private String timeZone;

    private String taxAgency;

    private BigDecimal amount;

    private String fileUploadIds;

    private List<DidiFileUploadDetailResult> fileUploads;

    private Integer handleFlag;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long commonId;

    private String commonName;

    private String groupName;

    private Integer groupIndex;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long groupId;

    public boolean isBacklogAutoFlag() {
        return backlogAutoFlag;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public Integer getGroupIndex() {
        return groupIndex;
    }

    public void setGroupIndex(Integer groupIndex) {
        this.groupIndex = groupIndex;
    }

    public Long getGroupId() {
        return groupId;
    }

    public void setGroupId(Long groupId) {
        this.groupId = groupId;
    }

    public Long getCommonId() {
        return commonId;
    }

    public void setCommonId(Long commonId) {
        this.commonId = commonId;
    }

    public String getCommonName() {
        return commonName;
    }

    public void setCommonName(String commonName) {
        this.commonName = commonName;
    }
    public Integer getHandleFlag() {
        return handleFlag;
    }

    public void setHandleFlag(Integer handleFlag) {
        this.handleFlag = handleFlag;
    }
    public List<DidiFileUploadDetailResult> getFileUploads() {
        return fileUploads;
    }

    public void setFileUploads(List<DidiFileUploadDetailResult> fileUploads) {
        this.fileUploads = fileUploads;
    }

    public String getFileUploadIds() {
        return fileUploadIds;
    }

    public void setFileUploadIds(String fileUploadIds) {
        this.fileUploadIds = fileUploadIds;
    }

    public String getTimeZone() {
        return timeZone;
    }

    public void setTimeZone(String timeZone) {
        this.timeZone = timeZone;
    }

    public String getTaxAgency() {
        return taxAgency;
    }

    public void setTaxAgency(String taxAgency) {
        this.taxAgency = taxAgency;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public String getBacklogStatusStr() {
        return BackLogEnum.DetailStatus.MAPPING.get(this.backlogStatus);
    }

    public String getBacklogGenerateTypeStr() {
        return BackLogEnum.GenerateType.MAPPING.get(this.getBacklogGenerateType());
    }
    public String getBacklogAutoFlagStr() {
        return BackLogEnum.AutoFlagType.MAPPING.get(this.getBacklogAutoFlag());
    }

    public boolean getBacklogAutoFlag() {
        return backlogAutoFlag;
    }

    public void setBacklogAutoFlag(boolean backlogAutoFlag) {
        this.backlogAutoFlag = backlogAutoFlag;
    }

    public String getBacklogDescribe() {
        return backlogDescribe;
    }

    public void setBacklogDescribe(String backlogDescribe) {
        this.backlogDescribe = backlogDescribe;
    }

    public Date getChinaBacklogStartDate() {
        return chinaBacklogStartDate;
    }

    public void setChinaBacklogStartDate(Date chinaBacklogStartDate) {
        this.chinaBacklogStartDate = chinaBacklogStartDate;
    }

    public Date getChinaBacklogEndDate() {
        return chinaBacklogEndDate;
    }

    public void setChinaBacklogEndDate(Date chinaBacklogEndDate) {
        this.chinaBacklogEndDate = chinaBacklogEndDate;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getBusinessLine() {
        return businessLine;
    }

    public void setBusinessLine(String businessLine) {
        this.businessLine = businessLine;
    }

    public String getBacklogName() {
        return backlogName;
    }

    public void setBacklogName(String backlogName) {
        this.backlogName = backlogName;
    }

    public String getBacklogStatus() {
        return backlogStatus;
    }

    public void setBacklogStatus(String backlogStatus) {
        this.backlogStatus = backlogStatus;
    }

    public Date getBacklogStartDate() {
        return backlogStartDate;
    }

    public void setBacklogStartDate(Date backlogStartDate) {
        this.backlogStartDate = backlogStartDate;
    }

    public Date getBacklogEndDate() {
        return backlogEndDate;
    }

    public void setBacklogEndDate(Date backlogEndDate) {
        this.backlogEndDate = backlogEndDate;
    }

    public String getDealUser() {
        return dealUser;
    }

    public void setDealUser(String dealUser) {
        this.dealUser = dealUser;
    }

    public String getAuditUser() {
        return auditUser;
    }

    public void setAuditUser(String auditUser) {
        this.auditUser = auditUser;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getCurrentUser() {
        return currentUser;
    }

    public void setCurrentUser(String currentUser) {
        this.currentUser = currentUser;
    }

    public Long getBacklogTypeId() {
        return backlogTypeId;
    }

    public void setBacklogTypeId(Long backlogTypeId) {
        this.backlogTypeId = backlogTypeId;
    }

    public Integer getBacklogGenerateType() {
        return backlogGenerateType;
    }

    public void setBacklogGenerateType(Integer backlogGenerateType) {
        this.backlogGenerateType = backlogGenerateType;
    }

    public Integer getOutTimeFlag() {
        return outTimeFlag;
    }

    public void setOutTimeFlag(Integer outTimeFlag) {
        this.outTimeFlag = outTimeFlag;
    }

    public String getBacklogCode() {
        return backlogCode;
    }

    public void setBacklogCode(String backlogCode) {
        this.backlogCode = backlogCode;
    }

    public String getBacklogGroupCode() {
        return backlogGroupCode;
    }

    public void setBacklogGroupCode(String backlogGroupCode) {
        this.backlogGroupCode = backlogGroupCode;
    }

}
