package pwc.taxtech.atms.pwc.websocket;

import org.apache.ibatis.session.SqlSessionFactory;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import pwc.taxtech.atms.common.util.SpringContextUtil;
import pwc.taxtech.atms.dao.PwcTaskMapper;
import pwc.taxtech.atms.entity.PwcTask;
import pwc.taxtech.atms.entity.PwcTaskExample;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @version 1.0
 * @program: atms
 * @description:
 * @author: Kevin
 * @create: 2019-05-24 14:58
 **/
@Component
public class TaskInfomationThread implements Runnable {
    private int during;
    private boolean stopMe = true;
    private int sum = 0;
    private int new_sum;
    private static final String type = "pushTaskInfo";
    private String interActiveId;
    private List<PwcTask> tasks;

    public String getInterActiveId() {
        return interActiveId;
    }

    public void setInterActiveId(String interActiveId) {
        this.interActiveId = interActiveId;
    }

    private static org.slf4j.Logger logger = LoggerFactory.getLogger(MyThread.class);

    public void stopMe() {
        stopMe = false;
    }

    private PwcTaskMapper pwcTaskMapper = SpringContextUtil.getBean(PwcTaskMapper.class);
    private SqlSessionFactory sqlSessionFactory = SpringContextUtil.getBean(SqlSessionFactory.class);
    public void run() {
      //  SqlSessionUtils.getSqlSession(sqlSessionFactory).clearCache();
        while (stopMe) {
            PwcTaskExample example = new PwcTaskExample();
            example.createCriteria().andInteractiveIdEqualTo(interActiveId);
            List<PwcTask> pwcTasks = pwcTaskMapper.selectByExample(example);
            new_sum = pwcTasks.size();
            if (new_sum != sum) {
                sum = new_sum;
                Map map = new HashMap<>();
                map.put("pushTaskInfo", pwcTasks);
                WebSocket wbs = new WebSocket(interActiveId, type, map);
                wbs.onMessage(1);
            }
            try {
                Thread.sleep(3000);
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
}