package pwc.taxtech.atms.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.client.RestTemplate;
import pwc.taxtech.atms.common.AtmsApiSettings;
import pwc.taxtech.atms.common.AuthUserHelper;
import pwc.taxtech.atms.common.ResponseMessageBuilder;
import pwc.taxtech.atms.common.util.BeanUtil;
import pwc.taxtech.atms.common.util.SpringContextUtil;
import pwc.taxtech.atms.dao.UserMapper;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.vatdto.CellDataDto;
import pwc.taxtech.atms.entity.User;
import pwc.taxtech.atms.entity.UserExample;
import pwc.taxtech.atms.security.dd.DtsTokenService;

import java.util.ArrayList;
import java.util.List;

public class BaseService {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    protected AuthUserHelper authUserHelper;
    @Autowired
    protected AtmsApiSettings atmsApiSettings;
    @Autowired
    protected OperationLogServiceImpl operationLogService;
    @Autowired
    protected DistributedIdService idService;
    @Autowired
    protected BeanUtil beanUtil;
    @Autowired
    protected RestTemplate restTemplate;
    @Autowired
    protected CommonDocumentHelper commonDocumentHelper;
    @Autowired
    protected ResponseMessageBuilder responseMessageBuilder;
    @Autowired
    protected DtsTokenService dtsTokenService;
    public  OperationResultDto operationResultDto;
    public static  List<CellDataDto> _cellData = new ArrayList<>();

    public User getUserById(String userId){
        UserExample userExample =new UserExample();
        userExample.createCriteria().andIdEqualTo(userId);
        UserMapper userMapper= SpringContextUtil.getBean(UserMapper.class);
        List<User> users = userMapper.selectByExample(userExample);
        return users.get(0);
    }

}
