package pwc.taxtech.atms.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dao.InteractionalLinkMapper;
import pwc.taxtech.atms.dpo.InteractionalLinkDto;
import pwc.taxtech.atms.dpo.TaxEmailDto;
import pwc.taxtech.atms.entity.InteractionalLink;

import java.util.Date;
import java.util.List;

/**
 * @description:
 * @author: sam
 * @create: 2019-05-22 20:46
 **/
@Service
public class InteractionLinkServiceImpl extends BaseService {
    private Logger logger = LoggerFactory.getLogger(InteractionLinkServiceImpl.class);

    @Autowired
    InteractionalLinkMapper interactionalLinkMapper;


    public List<InteractionalLinkDto> listAdminLink(InteractionalLinkDto param) {
        List<InteractionalLinkDto> InteractionalLinkDtos = interactionalLinkMapper.listByAdminDto(param);
        InteractionalLinkDtos.forEach(e->e.setCreateBy(getUserById(authUserHelper.getCurrentUserId()).getUserName()));
        return InteractionalLinkDtos;
    }


    public List<InteractionalLinkDto> listLink(InteractionalLinkDto param) {
        List<InteractionalLinkDto> InteractionalLinkDtos = interactionalLinkMapper.listByDto(param);
        InteractionalLinkDtos.forEach(e->e.setCreateBy(getUserById(authUserHelper.getCurrentUserId()).getUserName()));
        return InteractionalLinkDtos;
    }

    public InteractionalLink getLinkById(String id) {

        return interactionalLinkMapper.getLinkById(id);
    }

    public void insert(InteractionalLink interactionalLink) {
        interactionalLink.setId(String.valueOf(idService.nextId()));
        interactionalLink.setCreateBy(authUserHelper.getCurrentUserId());
        interactionalLink.setCreateTime(new Date());
        interactionalLinkMapper.insertSelective(interactionalLink);
    }

    public void edit(InteractionalLink interactionalLink) {
        interactionalLink.setUpdateBy(authUserHelper.getCurrentUserId());
        interactionalLink.setUpdateTime(new Date());
        interactionalLinkMapper.update(interactionalLink);
    }

    public void delete(String id) {
        interactionalLinkMapper.deleteById(id);
    }
}
