﻿infrastructureModule.controller('interactiveAdminController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter) {
            $scope.localData = {};
            $scope.pagingOptions = {
                totalItems: 10,  //总数据
            };
            $scope.loadMainData = function () {
                var config = {
                    params: {}
                };

                interactionService.getInteractiveAdminLists(config).then(function (data, status, headers) {
                    var data = data.data;
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (data.resultMsg == 'success') {
                        $scope.dataGridUpdate(data);
                    } else {
                        SweetAlert.error("互动信息加载失败");
                    }

                });
            };
            $scope.dataGridUpdate = function (_data) {

                $scope.localData = _data.data;
                $scope.pagingOptions = {
                    totalItems: $scope.localData.length,  //总数据
                };

                $scope.dataGridOptions = {
                    // dataSource: {
                    //     store: $scope.localData.items,
                    //     reshapeOnPush: true
                    // },
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    // repaintChangesOnly: true,
                    // twoWayBindingEnabled: true,
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 0,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "shareManage",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        {
                            dataField: "title",
                            caption: $translate.instant('ContentTitle'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    var star = options.data.essenceFlag == 1 ? '<i style="color:orange;" class="glyphicon glyphicon-star"></i>' : '';
                                    if (options.data.id) {
                                        $('<span ' + style + '>').text(options.data.title).appendTo(container);
                                        $(star).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "type",
                            caption: $translate.instant('ShareType'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    $('<span ' + style + '>').text($scope.emailType(options.data.type)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createBy",
                            caption: $translate.instant('Creator'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createBy) {
                                        $('<span ' + style + '>').text(options.data.createBy).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createTime",
                            caption: $translate.instant('CreatedTime'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createTime) {
                                        $('<span ' + style + '>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "operation",
                            caption: $translate.instant('Operation'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    var s = "";
                                    var t = 0;
                                    if (options.data.essenceFlag != 1) {
                                        t = 1;
                                        s = '<a style="color:#506bf7;"   class="settingA" onclick =  inter.doRecommended("' + options.data.id + '","' + t + '")  data-id="' + options.data.id + '" href="javascript:void(0)"><i class="glyphicon glyphicon-star"></i><span>' + $translate.instant("Set as recommended") + '</span></a>'
                                    } else {
                                        s = '<a style="color:#506bf7;"   class="settingA"   onclick =  inter.doRecommended("' + options.data.id + '","' + t + '") data-id="' + options.data.id + '" href="javascript:void(0)"><i class="glyphicon glyphicon-star"></i><span>' + $translate.instant("Cancel as recommended") + '</span></a>'
                                    }

                                    var eventTarget = $('<a style="color:#506bf7;" class="settingA"  onclick="inter.doEidt(\'' + options.data.id + '\', ' + options.data.type + ')" href="javascript:void(0)"><i class="glyphicon glyphicon-pencil"></i><span>' + $translate.instant("Edit") + '</span></a>' +
                                        '<a style="color:#506bf7;"   class="settingA"   onclick=inter.doDelete("' + options.data.id + '") data-id="' + options.data.id + '" href="javascript:void(0)"><i class="glyphicon glyphicon-remove"></i><span>' + $translate.instant("BtnDelete") + '</span></a>' + s
                                        /* '<a style="color:#506bf7;"  class="settingA"     onclick="inter.doMove(\'' + options.data.id + '\')" data-id="' + options.data.id + '" href="javascript:void(0)">\n' +*/
                                        /*'<i  class="glyphicon glyphicon-eject"></i><span>' + $translate.instant("Move") + '</span></a>'*/
                                    );
                                    container.append(eventTarget);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                    ],
                    rowAlternationEnabled: false  //单双行颜色
                };
            };
            $scope.getTableHeight = function () {
                var row_height = $("table").find("tr").height();
                if (row_height) {
                    return {
                        height: (row_height * 12 + 100) + "px"
                    }
                }
            };

            $scope.emailType = function (type) {
                if (type == 1) {
                    return "留言";
                }

                else if (type == 2) {
                    return "提问";
                }
                else if (type == 3) {
                    return "投票";
                }
                else if (type == 4) {
                    return "任务";
                }
            };

            $scope.editModel = {
                "id": null,//主键id
                "essenceFlag": null,
                "topFlag": null,
                "delFlag": null,

            };

            //----------------------kevin insert -------------------------------
            window.inter = {};
            window.inter.doEidt = function (id, type) {
                if (type == 4) {
                    SweetAlert.info("修改任务等到任务发布界面");
                    return false;
                }
                interactionService.selectById(id).success(function (res) {
                    var data = res.data;
                    if (res.resultMsg == 'success') {
                        $scope.duringType = type;
                        if (type == 1) {
                            $scope.postMessage = data;
                            switchOperation(1);
                            $scope.richText.write(data.content);
                        } else if (type == 2) {
                            $scope.postQuestion = data;
                            switchOperation(2);
                            $scope.richText.write(data.content);
                        } else if (type == 3) {
                            $scope.postVote = data;
                            $scope._tag.emptyContent();
                            $scope._tag.addTagsContent("<input type=\"text\" id=\"tag1\" > ");
                            $scope._tag.inputDoms = ['tag1'];
                            $scope.$tags = $scope._tag.initOne(data.tag.toString().substring(2, data.tag.length - 2));
                            switchOperation(3);
                            setTimeout(function () {
                                $scope.richText.write(data.content);
                            }, 500);
                        }
                    }
                });
            };
            window.inter.doDelete = function (id) {
                interactionService.deleteInteractiveAdmin(id).success(function (res) {
                    if (res.resultMsg == 'success') {
                        SweetAlert.success("删除成功");
                        $scope.loadMainData();
                    } else {
                        SweetAlert.success("删除失败");
                    }
                });
            };
            /*    window.inter.doMove = function () {

                };*/
            window.inter.doRecommended = function (id, type) {
                interactionService.doRecommended(id, type).success(function (res) {
                    if (res.resultMsg == 'success') {
                        SweetAlert.success("设置成功");
                        $scope.loadMainData();
                    } else {
                        SweetAlert.success("设置失败");
                    }
                });
            };
            var postEdit = function () {

                if ($scope.richText.read().length <= 11) {
                    SweetAlert.info("至少输入5个字");
                    return false;
                }
                switch ($scope.duringType) {
                    case 1:
                        if ($scope.postMessage.title == '') {
                            SweetAlert.info("请输入标题");
                            return false;
                        }
                        $scope.postData = $scope.postMessage;
                        break;
                    case 2:
                        if ($scope.postQuestion.title == '') {
                            SweetAlert.info("请输入标题");
                            return false;
                        }
                        $scope.postData = $scope.postQuestion;
                        break;
                    case 3:
                        if ($scope.postVote.title == '') {
                            SweetAlert.info("请输入标题");
                            return false;
                        }
                        $scope.postData = $scope.postVote;
                        break;
                }
                $scope.postData.content = $scope.richText.read();
                $scope.postData.tag = JSON.stringify($scope._tag.getValueById('#tag1'));
                delete $scope.postData.createTime;
                interactionService.postEdit($scope.postData, $scope.duringType).success(function (res) {
                    if (res.resultMsg == "success") {
                        SweetAlert.success("修改成功");
                    } else {
                        SweetAlert.error("修改失败");
                    }
                    $scope.loadMainData();
                });
            }

            var switchOperation = function (type) {
                switch (type) {
                    case 1:
                        caseType1()
                        break;
                    case 2:
                        caseType2()
                        break;
                    case 3:
                        caseType3()
                        break;
                }
            }
            var caseType1 = function () {//发布留言
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor', 0);
                }
                $('#postMessage').modal();
            }
            var caseType2 = function () {//发布提问
                if ($scope.$editor1 == undefined) {
                    $scope.$editor1 = $scope.editorInit('editor1', 1);
                }
                $('#postQuestion').modal();
            }
            var caseType3 = function () {//发起投票
                    if ($scope.$editor2 == undefined) {
                        $scope.$editor2 = $scope.editorInit('editor2', 2);
                    }
                    $('#postvote').modal();
                }
                //----------------------insert end -------------------------------
            ;(function initialize() {
                $scope.loadMainData();
                $scope.postEdit = postEdit;
            })();
        }]);
