﻿infrastructureModule.controller('taxManageController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter', 'apiInterceptor', 'jqFetch',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter, apiInterceptor, jqFetch) {

            $scope.localData = {};
            $scope.pagingOptions = {
                totalItems: 10,  //总数据
            };

            var loadTagData = function (tag) {
                var config = {
                    //3 是滴滴税管标签
                    type: tag
                };
                jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/getTagList', config).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.tags = data.data;

                    })
            };


            $scope.loadMainData = function () {
                var config = {
                    params: {}
                };
                interactionService.getTaxManageList(config).then(function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.dataGridUpdate(data);
                })
            };
            $scope.dataGridUpdate = function (_data) {
                $scope.localData = _data;
                $scope.pagingOptions = {
                    totalItems: $scope.localData.length,  //总数据
                };
                $scope.dataGridOptions = {
                    // dataSource: {
                    //     store: $scope.localData.items,
                    //     reshapeOnPush: true
                    // },
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    // repaintChangesOnly: true,
                    // twoWayBindingEnabled: true,
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 0,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "shareManage",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        /*{
                            dataField: "id",
                            caption: $translate.instant('SequenceNumber'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style =  options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.id) {
                                        $('<span ' + style + '>').text(options.data.id).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },*/
                        {
                            dataField: "title",
                            caption: $translate.instant('ContentTitle'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.title) {
                                        $('<span ' + style + '>').text(options.data.title).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },

                        {
                            dataField: "createBy",
                            caption: $translate.instant('Creator'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createBy) {
                                        $('<span ' + style + '>').text(options.data.createBy).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createTime",
                            caption: $translate.instant('CreatedTime'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createTime) {
                                        $('<span ' + style + '>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "delFlag",
                            caption: $translate.instant('IsDisplay'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.delType(options.data.delFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "tag",
                            caption: $translate.instant('Tag'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.tag) {
                                        $('<span ' + style + '>').text(options.data.tag).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },

                        {
                            dataField: "operation",
                            caption: $translate.instant('Operation'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    var eventTarget = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("Edit") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTarget.off('click').on('click', function () {
                                        $scope.openEditPop(options.data);
                                    });

                                    var eventTargetDel = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("cellCommentDelete") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTargetDel.off('click').on('click', function () {
                                        $scope.deleteLink(options.data);
                                    });

                                    eventTarget.appendTo(container);
                                    eventTargetDel.appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                    ],
                    rowAlternationEnabled: false  //单双行颜色
                };
            };


            $scope.getTableHeight = function () {
                var row_height = $("table").find("tr").height();
                if (row_height) {
                    return {
                        height: (row_height * 12 + 100) + "px"
                    }
                }
            };

            //删除
            $scope.deleteLink = function (item) {

                SweetAlert.swal({
                        title: '确定删除吗？',
                        text: '',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            var message = {};
                            jqFetch.post(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/delete/' + item.id, message).then(
                                function (data, status, headers) {
                                    if (data.code == -1) {
                                        SweetAlert.warning("删除失败");
                                        return;
                                    }
                                    swal.close();
                                    $scope.loadMainData();
                                });
                        } else {
                            swal.close();
                        }
                    });
            }

            $scope.addTaxManage = function () {
                endProcess();
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor', 0);
                }
                setTimeout(function () {
                    $scope.richText.write('');
                }, 300)

                $scope.title = '';
                $scope.tag = '';
                $scope.editType = 0;
                $('#postMessage').modal();
            }


            var editTaxManage = function (item) {
                endProcess();

                jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/' + item.id).then(
                    function (data, status, headers) {

                        if ($scope.$editor == undefined) {
                            $scope.$editor = $scope.editorInit('editor', 0);
                        }
                        setTimeout(function () {
                            $scope.richText.write(data.data.content);
                        }, 300)

                        $scope.title = data.data.title;
                        $scope.tag = data.data.tag;
                        $scope.editType = 1;
                        $scope.taxManageId = data.data.id;
                        $('#postMessage').modal();
                    })


            };

            var postMessageSubmit = function () {

                if ($scope.title == undefined ||$scope.title == '') {
                    SweetAlert.info("请输入标题");
                    return false;
                }
                if ($scope.richText.read().length <= 11) {
                    SweetAlert.info("至少输入5个字");
                    return false;
                }
                if ($scope.tag == undefined ||$scope.tag == '') {
                    SweetAlert.info("请选择标签");
                    return false;
                }
                var message = {
                    content: $scope.richText.read(),
                    title: $scope.title,
                    tag: $scope.tag
                }
                if ($scope.editType == 0) {
                    jqFetch.post(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/add', message).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.richText.write("");
                            $scope.title = '';
                            $scope.tag = '';
                            $scope.loadMainData();
                        })
                }
                else if ($scope.editType == 1) {
                    message.id = $scope.taxManageId;
                    jqFetch.post(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/edit', message).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.richText.write("");
                            $scope.title = '';
                            $scope.tag = '';
                            $scope.loadMainData();
                        })
                }

            };


            $scope.delType = function (type) {
                if (type == 1) {
                    return "不显示";
                }
                else {
                    return "显示";
                }
            };
            //标签
            function pwcTag(id, tagname, visible) {
                this.tagname = tagname;
                this.id = id,
                    this.visible = visible != undefined ? visible : false;
            }
            //整合数据
            var endProcess = function () {
                $scope.share = {};
                //加标签数据
                interactionService.getTagList(3).then(function (data, status, headers) {
                    if (data.data != null) {
                        var data = data.data;
                        $scope.shareTag = [];
                        data.forEach(function (value, i) {
                            $scope.shareTag.push(new pwcTag(value.id, value.tagname));
                        });
                    } else {
                        SweetAlert.error("加载标签列表失败");
                    }
                })
                $scope.tagSet = false;
                $scope.tagOperation = "添加标签";
            }

            $scope.share = {};
            $scope.createTag = function () {
                if ($scope.tagSet == false || $scope.tagSet == undefined) {
                    $scope.tagSet = true;
                    $("#tagInput").show();
                    $scope.tagOperation = "确定";
                } else {
                    if ($scope.share.addTag == "" || $scope.share.addTag == null || $scope.share.addTag == undefined) {
                        SweetAlert.info("输入标签不能为空");
                        return false;
                    }
                    interactionService.addTagSubmit($scope.share.addTag, 3).then(function (data, status, headers) {
                        if (data.resultMsg = "success") {
                            $scope.shareTag.push(new pwcTag(new Date().getTime(), $scope.share.addTag));
                            $scope.share.addTag = '';
                        } else {
                            SweetAlert.error("标签添加失败");
                        }
                        $scope.tagSet = false;
                        $scope.tagOperation = "添加标签";
                        $("#tagInput").hide();
                    })
                }
            }

            var checkUserPermission = function () {
                var list = [];
                $scope.hasTagPermission = false;
                var temp = constant.InteractionPermission;
                list.push(temp.tagOperate.code);
                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasTagPermission = data[temp.tagOperate.code];
                });
            };
            (function initialize() {
                $scope.loadTagData = loadTagData;
                $scope.editTaxManage = editTaxManage;
                $scope.loadMainData();
                loadTagData(3);
                checkUserPermission();
                $scope.postMessageSubmit = postMessageSubmit;
                //注册方法
                $scope.openEditPop = editTaxManage;
            })();
        }]);
