﻿vatModule.controller('backlogGroupController', ['$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q',
    '$interval', 'dxDataGridService', '$http', 'apiConfig', 'vatSessionService', 'apiInterceptor', 'jqFetch', '$filter', 'Upload',
    function ($scope, $log, $translate, $timeout, SweetAlert, $q, $interval, dxDataGridService, $http, apiConfig, vatSessionService, apiInterceptor, jqFetch, $filter, Upload) {
        'use strict';
        $log.debug('backlogGroupController.ctor()...');

        // var dataGrid = $("#detailGridContainer").dxDataGrid("instance");
        // var selectedKeys = dataGrid.getSelectedRowKeys();
        // var selectedData = dataGrid.getSelectedRowsData();

        //表格配置
        $scope.groupGridOptions = $.extend(true, {}, dxDataGridService.BASIC_GRID_OPTIONS, {
            showBorders: true,
            sorting: {//排序
                ascendingText: "Sort Ascending",
                clearText: "Clear Sorting",
                descendingText: "Sort Descending",
                mode: "single"
            },
            showRowLines: true,
            columnAutoWidth: true,
            allowColumnReordering: true,
            columns: [
                {
                    dataField: 'groupCode',
                    caption: $translate.instant('BGLColumnGroupCode'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'name',
                    caption: $translate.instant('BGLColumnName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'orgName',
                    caption: $translate.instant('BDLColumnOrgName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'businessLine',
                    caption: $translate.instant('BDLColumnBusinessLine'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'timeZone',
                    caption: $translate.instant('BGLColumnTimeZone'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'generateTypeStr',
                    caption: $translate.instant('BGLColumnGenerateType'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'createUserName',
                    caption: $translate.instant('BGLColumnCreator'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'statusStr',
                    caption: $translate.instant('BGLColumnStatus'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: '',
                    caption: $translate.instant('BGLColumnHandle'),
                    fixed: true,
                    width: '80px',
                    alignment: 'center',
                    cellTemplate: function (container, options) {
                        try {
                            $('<a>' + $translate.instant('BGLColumnHandleView') + '|</a>&nbsp;&nbsp;')
                                .on('click', function () {
                                    $scope.updateGroup(options.data, true);
                                }).appendTo(container);
                            if (options.data.status == 'UN_COMPLETED') {
                                $('<a >' + $translate.instant('BGLColumnHandleEdit') + '|</a>&nbsp;&nbsp;')
                                    .on('click', function () {
                                        $scope.updateGroup(options.data, false);
                                    }).appendTo(container);
                            }
                            if (options.data.status == 'COMPLETED') {
                                $('<a >' + $translate.instant('BGLColumnHandleAllot') + '|</a>&nbsp;&nbsp;')
                                    .on('click', function () {
                                        $scope.openAllottedConfigList(options.data);
                                    }).appendTo(container);
                            }
                        } catch (e) {
                            $log.error(e);
                        }
                    }
                },
            ],
            bindingOptions: {
                dataSource: 'pageConfDataSource'
            }
        });

        //已分配事项列表dx配置项
        $scope.allottedConfigGridOptions = $.extend(true, {}, dxDataGridService.BASIC_GRID_OPTIONS, {
            showBorders: true,
            sorting: {//排序
                ascendingText: "Sort Ascending",
                clearText: "Clear Sorting",
                descendingText: "Sort Descending",
                mode: "single"
            },
            showRowLines: true,
            columnAutoWidth: true,
            allowColumnReordering: true,
            columns: [
                {
                    dataField: '',
                    caption: $translate.instant('BCLColumnType'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        var backlogType = $filter('filter')($scope.backlogTypeData, {id: data.backlogTypeId})[0];
                        var parentBacklogType = $filter('filter')($scope.backlogTypeData, {id: backlogType.parentId})[0];
                        return parentBacklogType.name;
                    }
                },
                {
                    dataField: '',
                    caption: $translate.instant('BCLColumnSubType'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        var backlogType = $filter('filter')($scope.backlogTypeData, {id: data.backlogTypeId})[0];
                        return backlogType.name;
                    }
                },
                {
                    dataField: 'name',
                    caption: $translate.instant('BCLColumnName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'businessLineName',
                    caption: $translate.instant('BCLColumnBusinessLine'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'orgName',
                    caption: $translate.instant('BCLColumnOrgName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'validityStartDate',
                    caption: $translate.instant('BCLColumnStartDate'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        return $filter('date')(data.validityStartDate, 'yyyy-MM-dd HH:mm:ss');
                    }

                },
                {
                    dataField: 'validityEndDate',
                    caption: $translate.instant('BCLColumnEndDate'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        return $filter('date')(data.validityEndDate, 'yyyy-MM-dd HH:mm:ss');
                    }
                },
                {
                    dataField: 'dealUserName',
                    caption: $translate.instant('BCLColumnDealUser'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'auditUserName',
                    caption: $translate.instant('BCLColumnAuditUser'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'createUserName',
                    caption: $translate.instant('BCLColumnCreate'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'groupIndex',
                    caption: $translate.instant('BCLColumnGroupIndex'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: '',
                    caption: $translate.instant('BCLColumnHandle'),
                    fixed: true,
                    width: '80px',
                    alignment: 'center',
                    cellTemplate: function (container, options) {
                        try {
                            if (options.rowIndex > 0) {
                                $('<a>' + $translate.instant('BCLColumnHandleUp') + '|</a>&nbsp;&nbsp;')
                                    .on('click', function () {
                                        $scope.sortAllottedConfigList(options.rowIndex, 'up');
                                    }).appendTo(container);
                            }
                            if (options.rowIndex < $scope.allottedConfigListDataSource.length - 1) {
                                $('<a>' + $translate.instant('BCLColumnHandleDown') + '|</a>&nbsp;&nbsp;')
                                    .on('click', function () {
                                        $scope.sortAllottedConfigList(options.rowIndex, 'down');
                                    }).appendTo(container);
                            }
                            $('<a>' + $translate.instant('BCLColumnHandleDelete') + '|</a>&nbsp;&nbsp;')
                                .on('click', function () {
                                    $scope.delAllottedConfig(options.rowIndex);
                                }).appendTo(container);
                        } catch (e) {
                            $log.error(e);
                        }
                    }
                },
            ],
            bindingOptions: {
                dataSource: 'allottedConfigListDataSource'
            }
        });

        //已分配事项列表dx配置项
        $scope.unAllotConfigGridOptions = $.extend(true, {}, dxDataGridService.BASIC_GRID_OPTIONS, {
            showBorders: true,
            sorting: {//排序
                ascendingText: "Sort Ascending",
                clearText: "Clear Sorting",
                descendingText: "Sort Descending",
                mode: "single"
            },
            showRowLines: true,
            columnAutoWidth: true,
            allowColumnReordering: true,
            columns: [
                {
                    dataField: '',
                    caption: $translate.instant('BCLColumnType'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        var backlogType = $filter('filter')($scope.backlogTypeData, {id: data.backlogTypeId})[0];
                        var parentBacklogType = $filter('filter')($scope.backlogTypeData, {id: backlogType.parentId})[0];
                        return parentBacklogType.name;
                    }
                },
                {
                    dataField: '',
                    caption: $translate.instant('BCLColumnSubType'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        var backlogType = $filter('filter')($scope.backlogTypeData, {id: data.backlogTypeId})[0];
                        return backlogType.name;
                    }
                },
                {
                    dataField: 'name',
                    caption: $translate.instant('BCLColumnName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'businessLineName',
                    caption: $translate.instant('BCLColumnBusinessLine'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'orgName',
                    caption: $translate.instant('BCLColumnOrgName'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'validityStartDate',
                    caption: $translate.instant('BCLColumnStartDate'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        return $filter('date')(data.validityStartDate, 'yyyy-MM-dd HH:mm:ss');
                    }
                },
                {
                    dataField: 'validityEndDate',
                    caption: $translate.instant('BCLColumnEndDate'),
                    fixed: true,
                    allowHeaderFiltering: true,
                    calculateCellValue: function (data) {
                        return $filter('date')(data.validityEndDate, 'yyyy-MM-dd HH:mm:ss');
                    }
                },
                {
                    dataField: 'dealUserName',
                    caption: $translate.instant('BCLColumnDealUser'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'auditUserName',
                    caption: $translate.instant('BCLColumnAuditUser'),
                    fixed: true,
                    allowHeaderFiltering: true
                },
                {
                    dataField: 'createUserName',
                    caption: $translate.instant('BCLColumnCreate'),
                    fixed: true,
                    allowHeaderFiltering: true
                }
            ],
            bindingOptions: {
                dataSource: 'unAllotConfigListDataSource'
            },
            onRowClick: function (option) {
                var data = option.data;
                data.groupId = $scope.selectedGroupData.id;
                data.groupIndex = $scope.allottedConfigListDataSource.length + 1;
                $scope.allottedConfigListDataSource.push(data);
                $scope.allottedConfigIds[data.id] = true;
                $($scope.unAllotConfigListDiv).modal('hide');
            }
        });




        $scope.saveAllottedConfig = function () {
            var dataListParam = [];
            angular.forEach($scope.allottedConfigListDataSource, function (item) {
                dataListParam.push({
                    "id": item.id,
                    "groupId": item.groupId,
                    "groupIndex": item.groupIndex
                });
            });
            $http.post('/backlogManage/backlog/config/group/edit', {
                "paramList": dataListParam,
                "groupId": $scope.selectedGroupData.id
            }, apiConfig.createVat())
                .success(function (res) {
                    if (res && 0 === res.code) {
                        SweetAlert.success($translate.instant('BGLAllotConfigSuccess'));
                        $($scope.allottedConfigListDiv).modal('hide');
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                });
        }
        $scope.delAllottedConfig = function (index) {
            $scope.allottedConfigListDataSource.splice(index, 1);
            angular.forEach($scope.allottedConfigListDataSource, function (item, i) {
                item.groupIndex = i + 1;
            });
        }
        $scope.sortAllottedConfigList = function (index, type) {
            var oldData = $scope.allottedConfigListDataSource[index];
            var sourceIndex = 0;
            if ('down' == type) {
                sourceIndex = index + 1;
            }
            if ('up' == type) {
                sourceIndex = index - 1;
            }
            $scope.allottedConfigListDataSource[index] = $scope.allottedConfigListDataSource[sourceIndex];
            $scope.allottedConfigListDataSource[index].groupIndex = index + 1;
            $scope.allottedConfigListDataSource[sourceIndex] = oldData;
            $scope.allottedConfigListDataSource[sourceIndex].groupIndex = sourceIndex + 1;
        }

        //弹出事项选择列表
        $scope.openUnAllotConfigList = function () {
            $($scope.unAllotConfigListDiv).modal('show');
            $scope.refreshUnAllotConfigListGrid();
        };
        //弹出事项管理列表
        $scope.openAllottedConfigList = function (groupData) {
            $scope.allottedConfigIds = [];
            $scope.selectedGroupData = groupData;
            $($scope.allottedConfigListDiv).modal('show');
            $scope.refreshAllottedConfigListGrid();
        };

        $scope.addGroup = function () {
            $scope.groupEdit = {};
            $scope.groupReadOnly = false;
            $($scope.groupEditDiv).modal('show');
        };

        $scope.updateGroup = function (group,readOnly) {
            $scope.groupEdit = group;
            $scope.groupReadOnly = readOnly;
            $scope.groupEdit.choose = !group.orgId ? '2' : '1';
            $($scope.groupEditDiv).modal('show');
        };
        $scope.conformEditGroup = function (status) {
            $scope.groupEdit.status = status;
            if(!$scope.groupEdit.choose ){
                SweetAlert.error($translate.instant('BGLEditColumnChooseError'));
                return;
            }else if($scope.groupEdit.choose == '1'&&!$scope.groupEdit.orgId){
                SweetAlert.error($translate.instant('BGLEditColumnOrgError'));
                return;
            }else if($scope.groupEdit.choose == '2'&&!$scope.groupEdit.businessLineId){
                SweetAlert.error($translate.instant('BGLEditColumnBusinessError'));
                return;
            }
            $http.post('/backlogManage/backlog/group/edit', $scope.groupEdit, apiConfig.createVat())
                .success(function (res) {
                    if (res && 0 === res.code) {
                        if ('UN_COMPLETED' == status) {
                            SweetAlert.success($translate.instant('BGLEditSuccess'));
                        } else if ('COMPLETED' == status) {
                            SweetAlert.success($translate.instant('BGLEditComplete'));
                        }
                        $scope.refreshGrid();
                        $($scope.groupEditDiv).modal('hide');
                    } else if(res && -1 === res.code){
                        var msg = '';
                        angular.forEach(res.message.split(','),function (errorMsg) {
                            msg+=$translate.instant(errorMsg)+"\r\n";
                        });
                        SweetAlert.error(msg);
                    }else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                });
        };
        //关闭配置框
        $scope.cancelModal = function () {
            $('#configForm')[0].reset();
        };

        $scope.selectedBacklog = [];

        $scope.businessListData = [];
        $scope.orgListData = null;
        $scope.getOrglist = function () {
            jqFetch.get(apiInterceptor.webApiHostUrl + '/org/getMyOrgList')
                .then(function (res) {
                    if (res && 0 === res.code) {
                        $scope.orgListData = res.data;
                        var dataMap = [];
                        angular.forEach(res.data, function (item) {
                            dataMap[item.businessUnitId] = item.businessUnitName;
                        });
                        for (var key in dataMap) {
                            if (key != 'null' && key.length > 18) {
                                $scope.businessListData.push({"ID": key, "name": dataMap[key]});
                            }

                        }
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };
        $scope.timeZoneData = [];
        $scope.getTimeZone = function () {
            $.get('app-resources/timezones/timezones.json', function (timezone) {
                angular.forEach(timezone, function (item) {
                    $scope.timeZoneData.push({
                        'key': item.timezone + '(' + item.zonename + ')', 'val': item.timezone
                    });
                });
            });
        };

        //刷新页面
        $scope.refreshGrid = function () {
            $scope.searchParam.pageInfo = {
                pageIndex: $scope.pagingOptions.pageIndex,
                totalItems: $scope.pagingOptions.totalItems,
                pageSize: $scope.pagingOptions.pageSize
            };
            $http.post('/backlogManage/backlog/group', $scope.searchParam, apiConfig.createVat())
                .success(function (res) {
                    if (res && res.list) {
                        $scope.pageConfDataSource = res.list;
                        $scope.pagingOptions.totalItems = res.pageInfo.totalCount;
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };

        //刷新事项选择页面
        $scope.refreshUnAllotConfigListGrid = function () {
            var searchParam = {
                "hasGroup": false,
                "orgId": $scope.selectedGroupData.orgId,
                "businessLineId": $scope.selectedGroupData.businessLineId,
                "timeZone": $scope.selectedGroupData.timeZone,
                "generateType":$scope.selectedGroupData.generateType,
                "autoFlag":$scope.selectedGroupData.autoFlag
            };
            $http.post('/backlogManage/backlog/config', searchParam, apiConfig.createVat())
                .success(function (res) {
                    if (res && res.list) {
                        $scope.unAllotConfigListDataSource = res.list;
                        $scope.unAllotConfigListDataSource = $filter('filter')($scope.unAllotConfigListDataSource, function (value) {
                            if ($scope.allottedConfigIds[value.id]) {
                                return false;
                            } else {
                                return true;
                            }
                        });
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };

        //刷新事项配置分配页面
        $scope.refreshAllottedConfigListGrid = function () {
            var searchParam = {
                "groupId": $scope.selectedGroupData.id
            };
            $http.post('/backlogManage/backlog/config', searchParam, apiConfig.createVat())
                .success(function (res) {
                    if (res && res.list) {
                        $scope.allottedConfigListDataSource = res.list;
                        $scope.allottedConfigListDataSource = $filter("orderBy")($scope.allottedConfigListDataSource, "groupIndex", false);
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };
        //获取事项类型选项列表
        $scope.backlogTypeData = null;
        $scope.getBacklogType = function () {
            jqFetch.get(apiInterceptor.webApiHostUrl + '/backlogManage/backlog/calendar/type')
                .then(function (res) {
                    if (res) {
                        $scope.backlogTypeData = res;
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }
                })
        };
        //搜索框的处理
        $scope.searchboxService = {

            showOrHideSearchBox: function () {
                $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
            },
            search: function () {
                $scope.pagingOptions.pageIndex = 1;
                $scope.refreshGrid();
            },
            resetBox: function () {
                $scope.searchParam = {};
            }
        };
        (function initialize() {
            //弹出模态框定义
            $scope.groupEditDiv = "#groupEditDiv";
            $scope.allottedConfigListDiv = "#allottedConfigListDiv";
            $scope.unAllotConfigListDiv = "#unAllotConfigListDiv";
            $scope.selectedGroupData = null;
            $scope.allottedConfigIds = [];
            $scope.groupEdit = {};
            $scope.formParam = {};
            //日期
            $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');

            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 20  //每页多少条数据
            };

            $scope.detailEditReadOnly = false;
            $scope.detailEdit = {};
            $scope.searchParam = {};
            $scope.detailSearchParam = {};
            $scope.searchOptions = {
                generalTypeOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    bindingOptions: {
                        value: 'searchParam.backlogGenerateType'
                    },
                    dataSource: [
                        {'key': '单次', 'val': 1},
                        {'key': '周期', 'val': 2}
                    ]
                },
                businessOptions: {
                    displayExpr: 'name',
                    valueExpr: 'ID',
                    // width: '95%',
                    bindingOptions: {
                        value: 'searchParam.businessLineId',
                        dataSource: 'businessListData'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true
                },
                orgOptions: {
                    displayExpr: 'name',
                    valueExpr: 'id',
                    deferRendering: false,
                    bindingOptions: {
                        value: 'searchParam.orgId',
                        dataSource: 'orgListData'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true
                },
                timeZoneOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    // width: '95%',
                    bindingOptions: {
                        value: 'searchParam.timeZone',
                        dataSource: 'timeZoneData'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true
                }
            };

            $scope.groupEditOptions = {
                autoFlagEditOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    bindingOptions: {
                        value: 'groupEdit.autoFlag',
                        readOnly: 'groupReadOnly'
                    },
                    dataSource: [
                        {'key': '是', 'val': true},
                        {'key': '否', 'val': false}
                    ]
                },
                generalTypeEditOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    bindingOptions: {
                        value: 'groupEdit.generateType',
                        readOnly: 'groupReadOnly'
                    },
                    dataSource: [
                        {'key': '单次', 'val': 1},
                        {'key': '周期', 'val': 2}
                    ]
                },
                chooseAllotOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    bindingOptions: {
                        value: 'groupEdit.choose',
                        readOnly: 'groupReadOnly'
                    },
                    dataSource: [
                        {'key': '公司', 'val': '1'},
                        {'key': '业务线', 'val': '2'}
                    ]
                },
                orgAllotOptions: {
                    displayExpr: 'name',
                    valueExpr: 'id',
                    deferRendering: false,
                    bindingOptions: {
                        value: 'groupEdit.orgId',
                        dataSource: 'orgListData',
                        readOnly: 'groupReadOnly'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true,
                    onSelectionChanged: function (obj) {
                        if(obj&&obj.selectedItem){
                            $scope.groupEdit.businessLineId = obj.selectedItem.businessUnitId;
                        }
                    }
                },
                businessAllotOptions: {
                    displayExpr: 'name',
                    valueExpr: 'ID',
                    // width: '95%',
                    bindingOptions: {
                        value: 'groupEdit.businessLineId',
                        dataSource: 'businessListData',
                        readOnly: 'groupReadOnly'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true
                },
                timeZoneAllotOptions: {
                    displayExpr: 'key',
                    valueExpr: 'val',
                    // width: '95%',
                    bindingOptions: {
                        value: 'groupEdit.timeZone',
                        dataSource: 'timeZoneData',
                        readOnly: 'groupReadOnly'
                    },
                    // height: '30px',
                    placeholder: '',
                    showClearButton: true,
                    searchEnabled: true,
                    showSelectionControls: true
                }
            };


            function init() {
                $scope.refreshGrid();
                $scope.getBacklogType();
                setTimeout(function () {
                    $scope.getOrglist();
                    $scope.getTimeZone();
                }, 1000);
            }

            init()

        })();
    }
]);