﻿commonModule.controller('importTBController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var _BlankChar = $translate.instant('PleaseSelectColumn');
        var resumable = true;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var projectId = vatSessionService.project.id;
        var servicePeriods = [];
     
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;      
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];       
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 }; //导入方式    
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;


        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('MyTrialBalanceTitle'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };



        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
                GetBalanceList();
            },
        };

        //初始化GridView
        var initGirdView = {
            initBalanceOuput: function () {
                return {
                    rowHeight: constant.UIGrid.rowHeight,
                    selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                    enableSorting: false,
                    enableColumnMenus: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                    columnDefs: [],
                    onRegisterApi: function (gridApi) {
                        $scope.gridApi = gridApi;

                        $interval(function () {
                            $scope.gridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                }
            },
            initErrorMsg: function () {
                return {
                    rowHeight: constant.UIGrid.rowHeight,
                    selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                    enableSorting: false,
                    enableColumnMenus: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
                    enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                    columnDefs: [
                        {
                            name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
                        },
                        {
                            name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
                        },
                        {
                            name: $translate.instant('InvoiceQJ'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}<span></div>'
                            , visible: $scope.serviceTypeId === constant.serviceType.CIT
                        },
                        {
                            name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
                        },
                        {
                            name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
                        },
                        {
                            name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: dealDetail(),
                        },
                        {
                            name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
                        },
                    ],
                    onRegisterApi: function (gridApi) {
                        $scope.errorGridApi = gridApi;

                        $interval(function () {
                            $scope.errorGridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                }
            }
        }


        //初始化列数据
        var initColumns = function () {
            //初始化进项发票汇总表列名
            $scope.mapNameList = [
                $translate.instant('PleaseSelectColumn'),
                $translate.instant('AccountCode'),
                $translate.instant('PeriodId'),
                $translate.instant('CustomerCode'),
                $translate.instant('BegDebitBal'),
                $translate.instant('BegCreditBal'),
                $translate.instant('EndDebitBal'),
                $translate.instant('EndCreditBal'),
                $translate.instant('DebitBal'),
                $translate.instant('CreditBal'),
                $translate.instant('BegBal'),
                $translate.instant('EndBal')
            ];
        };


        //上传文件
        var uploadfile = function (file) {
            if (file) {
                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file
                        },
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess);
                }
            }
        };


        //上传成功
        var uploadSuccess = function (resp) {
            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                changeSheet(0);
            }
        };


        //选择sheet
        var changeSheet = function (selectedSheet) {
            var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
                return num.name === selectedSheet.name;
            })
            $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
            refreshTable();
        };


        //刷新列表
        var refreshTable = function () {
            //在切换显示页面导入数据时，直接设置初始化数据ui-grid表不可见，错误信息不可见
            //导入数据表格可见 
            $scope.showErrorTable = false;
            if (_.isString($scope.tempFileName)) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                $scope.selectedMappingList = [];
                $scope.gridOptionsBalanceOuput.data = [];
                vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                    if (data.result === false) {
                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        initTableTitle();
                        SweetAlert.warning(data.resultMsg);
                    }
                    else {
                        $scope.showInitTable = false;
                        $scope.showImportTable = true
                    }
                    $scope.sheetData = data;
                    //加入index序号
                    var index = 1;
                    data.dataList.forEach(function (v) {
                        v.index = index++;
                    });
                    var sheetNameObjectArray = [];
                    data.sheetNameList.forEach(function (v) {
                        sheetNameObjectArray.push({ 'name': v });
                    });
                    $scope.sheetData.sheetNameList = sheetNameObjectArray;
                    $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                    initColumns();
                    vatSessionService.dataChanged = true;

                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        };


        //发票信息汇总数据表选择列名事件
        //parentIndex：当前列号
        //index：下拉列表中选项的序号
        var changeMapping = function (parentIndex, index, colName) {
            if (colName) {
                var newColumn = $scope.mapNameList[index];
                var oldColumn = $scope.selectedMappingList[parentIndex];

                //如果新的选择项与老的选择项一致，则不进行操作
                if (oldColumn === newColumn) {
                    return;
                }
                else {
                    $scope.selectedMappingList[parentIndex] = colName;

                    if (colName !== $translate.instant('PleaseSelectColumn')) {
                        //如果当前选择的不是"请选择列名",则将选项从数组中移除
                        $scope.mapNameList.splice(index, 1);

                        if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                            //将老的选项追加到选项列表中
                            $scope.mapNameList.push(oldColumn);
                        }
                    }
                    else {
                        //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                        if (oldColumn) {
                            $scope.mapNameList.push(oldColumn);
                        }
                    }
                }
            }
            $log.debug($scope.selectedMappingList);
        };


        //转换没有选中的列值
        var undefinedStringToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return "";
                }
                else {
                    return data;
                }
            }
        }


        //转换没有选中的列值
        var undefinedNumToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return 0;
                }
                else {
                    return data;
                }
            }
        }


        //验证每行数据类型
        var valueTypeValidation = function (balanceinputlist) {
        return true; //todo:[validation] to skip data validation (neo)
            var AccountCodeOverLengthMsg = '';
            var AccountCodeNullMsg = '';
            var PeriodMsg = '';
            var BegDebitBalMsg = '';
            var BegCreditBalMsg = '';
            var DebitBalMsg = '';
            var CreditBalMsg = '';
            var EndDebitBalMsg = '';
            var EndCreditBalMsg = '';
            var BegBalMsg = '';
            var EndBalMsg = '';
            var NumlengthMsg = '';

            var AccountCodeOverLengthCount = 0;
            var AccountCodeNullCount = 0;
            var PeriodCount = 0;
            var BegDebitBalCount = 0;
            var BegCreditBalCount = 0;
            var DebitBalCount = 0;
            var CreditBalCount = 0;
            var EndDebitBalCount = 0;
            var EndCreditBalCount = 0;
            var BegBalCount = 0;
            var EndBalCount = 0;
            var NumLengthCount = 0;
            //验证前，将错误数据清空
            $scope.errorMsgMap = [];
            for (var i = 0; i < balanceinputlist.length; i++) {
                var m = balanceinputlist[i];

                if (PWC.isNullOrEmpty(m.AcctCode)) {
                    AccountCodeNullMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('AccountCodeNullMag') + '<br />';
                    AccountCodeNullCount++;
                }
                if (m.AcctCode !== null && m.AcctCode.length > 50) {
                    AccountCodeOverLengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('AccountCodeOverLengthMag') + '<br />';
                    AccountCodeOverLengthCount++;
                }
                if (m.MonthId !== null) {
                    if (!PWC.isInteger(m.MonthId)) {
                        PeriodMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('PeriodErrorMag') + '<br />';
                        PeriodCount++;
                    }
                    else if (PWC.isInteger(m.MonthId) && (parseInt(m.MonthId) < 1 || parseInt(m.MonthId) > 12)) {
                        NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('PeriodId') + $translate.instant('PeriodOverLengthMsg') + '<br />';
                        NumLengthCount++;
                    }
                }

                if (m.BegDebitBal !== null) {
                    if (isNaN(parseFloat(m.BegDebitBal))) {
                        BegDebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegDebitBalMsg') + '<br />';
                        BegDebitBalCount++;
                    }
                    //else if (parseFloat(m.BegDebitBal) < constant.startNum || parseFloat(m.BegDebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegDebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegDebitBal = PWC.round(m.BegDebitBal, 2);
                    }


                }
                if (m.BegCreditBal !== null) {
                    if (isNaN(parseFloat(m.BegCreditBal))) {
                        BegCreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegCreditBalMsg') + '<br />';
                        BegCreditBalCount++;
                    }
                    //else if (parseFloat(m.BegCreditBal) < constant.startNum || parseFloat(m.BegCreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegCreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegCreditBal = PWC.round(m.BegCreditBal, 2);
                    }
                }
                if (m.DebitBal !== null) {
                    if (isNaN(parseFloat(m.DebitBal))) {
                        DebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('DebitBalMsg') + '<br />';
                        DebitBalCount++;
                    }
                    //else if (parseFloat(m.DebitBal) < constant.startNum || parseFloat(m.DebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('DebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.DebitBal = PWC.round(m.DebitBal, 2);
                    }
                }
                if (m.CreditBal !== null) {
                    if (isNaN(parseFloat(m.CreditBal))) {
                        CreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('CreditBalMsg') + '<br />';
                        CreditBalCount++;
                    }
                    //else if (parseFloat(m.CreditBal) < constant.startNum || parseFloat(m.CreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('CreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.CreditBal = PWC.round(m.CreditBal, 2);
                    }
                }
                if (m.EndDebitBal !== null) {
                    if (isNaN(parseFloat(m.EndDebitBal))) {
                        EndDebitBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndDebitBalMsg') + '<br />';
                        EndDebitBalCount++;
                    }
                    //else if (parseFloat(m.EndDebitBal) < constant.startNum || parseFloat(m.EndDebitBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndDebitBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndDebitBal = PWC.round(m.EndDebitBal, 2);
                    }
                }
                if (m.EndCreditBal !== null) {
                    if (isNaN(parseFloat(m.EndCreditBal))) {
                        EndCreditBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndCreditBalMsg') + '<br />';
                        EndCreditBalCount++;
                    }
                    //else if (parseFloat(m.EndCreditBal) < constant.startNum || parseFloat(m.EndCreditBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndCreditBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndCreditBal = PWC.round(m.EndCreditBal, 2);
                    }
                }
                if (m.BegBal !== null) {
                    if (isNaN(parseFloat(m.BegBal))) {
                        BegBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegBalMsg') + '<br />';
                        BegBalCount++;
                    }
                    //else if (parseFloat(m.BegBal) < constant.startNum || parseFloat(m.BegBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('BegBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.BegBal = PWC.round(m.BegBal, 2);
                    }
                }
                if (m.EndBal !== null) {
                    if (isNaN(parseFloat(m.EndBal))) {
                        EndBalMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndBalMsg') + '<br />';
                        EndBalCount++;
                    }
                    //else if (parseFloat(m.EndBal) < constant.startNum || parseFloat(m.EndBal) > constant.endNum) {
                    //    NumlengthMsg += $translate.instant('LineNum') + ':' + m.SeqNum + ',' + $translate.instant('EndBal') + $translate.instant('NumOverLengthMsg') + '<br />';
                    //    NumLengthCount++;
                    //}
                    else {
                        m.EndBal = PWC.round(m.EndBal, 2);
                    }
                }
            }


            if (AccountCodeNullMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AccountCodeNullType'),
                        'errorCount': AccountCodeNullCount,
                        'errorContent': AccountCodeNullMsg
                    });
            }
            if (AccountCodeOverLengthMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AccountCodeOverLengthType'),
                        'errorCount': AccountCodeOverLengthCount,
                        'errorContent': AccountCodeOverLengthMsg
                    });
            }
            if (NumLengthCount > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('NumOutRangeErrorType'),
                        'errorCount': NumLengthCount,
                        'errorContent': NumlengthMsg
                    });
            }
            if (PeriodMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('PeriodErrorType'),
                        'errorCount': PeriodCount,
                        'errorContent': PeriodMsg
                    });
            }
            if (BegDebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegDebitBalType'),
                        'errorCount': BegDebitBalCount,
                        'errorContent': BegDebitBalMsg
                    });
            }
            if (BegCreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegCreditBalType'),
                        'errorCount': BegCreditBalCount,
                        'errorContent': BegCreditBalMsg
                    });
            }
            if (CreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('CreditBalType'),
                        'errorCount': CreditBalCount,
                        'errorContent': CreditBalMsg
                    });
            }
            if (DebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('DebitBalType'),
                        'errorCount': DebitBalCount,
                        'errorContent': DebitBalMsg
                    });
            }
            if (EndDebitBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndDebitBalType'),
                        'errorCount': EndDebitBalCount,
                        'errorContent': EndDebitBalMsg
                    });
            }
            if (EndCreditBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndCreditBalType'),
                        'errorCount': EndCreditBalCount,
                        'errorContent': EndCreditBalMsg
                    });
            }
            if (BegBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BegBalType'),
                        'errorCount': BegBalCount,
                        'errorContent': BegBalMsg
                    });
            }
            if (EndBalMsg) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('EndBalType'),
                        'errorCount': EndBalCount,
                        'errorContent': EndBalMsg
                    });
            }
            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return false;
            }
            return true;
        }


        //验证是否选中了正确的列名
        var validationColumnMapping = function () {
            $scope.errorMsgMap = [];
            //0.判断选择的开始导入行是否大于实际数据行
            if (PWC.isNullOrEmpty($scope.startRowNum)) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
            }
            if (parseInt($scope.startRowNum) > $scope.sheetData.dataList.length) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
            }
            //1.科目代码必选
            if ($scope.selectedMappingList.indexOf($translate.instant('AccountCode')) === -1) {
                //errorMsg += $translate.instant('NoAccountCode') + '\n';           
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('NoAccountCode')
                    });
            }
            //借方期初，贷方期初同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition1')
                    });
            }
            //借方发生额，贷方发生额同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition6')
                    });
            }
            //借方期末，贷方期末同时必选
            if (($scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) === -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1)
                || ($scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1 &&
                    $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) === -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition7')
                    });
            }
            //2.期初余额必选或者(借方期初，贷方期初)必选
            if (!($scope.selectedMappingList.indexOf($translate.instant('BegBal')) !== -1 ||
                $scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1)) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition2')
                    });
            }
            //3.（借方发生额，贷方发生额）或者（借方期末，贷方期末）或者 期末余额 必选 
            if (!($scope.selectedMappingList.indexOf($translate.instant('DebitBal')) !== -1
                && $scope.selectedMappingList.indexOf($translate.instant('CreditBal')) !== -1
                || $scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1
                && $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1
                || $scope.selectedMappingList.indexOf($translate.instant('EndBal')) !== -1)
            ) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition3')
                    });
            }
            //4.期初余额与借方期初，贷方期初不能同时选
            if ($scope.selectedMappingList.indexOf($translate.instant('BegBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('BegCreditBal')) !== -1) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition4')
                    });
            }
            //5.期末余额与借方期末，贷方期末不能同时选
            if ($scope.selectedMappingList.indexOf($translate.instant('EndBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndDebitBal')) !== -1 &&
                $scope.selectedMappingList.indexOf($translate.instant('EndCreditBal')) !== -1) {

                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('Condition5')
                    });
            }

            //6. CIT时期间必须
            if ($scope.serviceTypeId === constant.serviceType.CIT
                && $scope.selectedMappingList.indexOf($translate.instant('PeriodId')) === -1) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('SelectColumnError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('PeriodColumnRequired')
                    });
            }

            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return false;
            }
            return true;
        }


        //验证数据
        var validationTbData = function () {
            var defer = $q.defer();
            $scope.balanceInputList = [];
            for (var i = $scope.startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
                var balanceDto = {
                    'SeqNum': i + 1,
                    'BalanceId': PWC.newGuid(),
                    'PeriodId': undefinedStringToNull(i, 'PeriodId'),
                    'AcctCode': undefinedStringToNull(i, 'AccountCode'),
                    'CustomerCode': undefinedStringToNull(i, 'CustomerCode'),
                    'MonthId': undefinedStringToNull(i, 'PeriodId'),
                    'BegDebitBal': undefinedNumToNull(i, 'BegDebitBal'),
                    'BegCreditBal': undefinedNumToNull(i, 'BegCreditBal'),
                    'DebitBal': undefinedNumToNull(i, 'DebitBal'),
                    'CreditBal': undefinedNumToNull(i, 'CreditBal'),
                    'EndDebitBal': undefinedNumToNull(i, 'EndDebitBal'),
                    'EndCreditBal': undefinedNumToNull(i, 'EndCreditBal'),
                    'BegBal': undefinedNumToNull(i, 'BegBal'),
                    'EndBal': undefinedNumToNull(i, 'EndBal'),
                };
                $scope.balanceInputList.push(balanceDto);
            }

            if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                $scope.isSelectPeriod = $scope.balanceInputList[0].MonthId !== null ? true : false;
                var isOk = valueTypeValidation($scope.balanceInputList);
                defer.resolve(isOk);
                return defer.promise;

            }
            else if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                if ($scope.balanceInputList[0].MonthId === null) {//没有选中月份,默认导入所有期间
                    $scope.isSelectPeriod = false;
                    swal({
                        title: "warning!",
                        text: $translate.instant('NoPeriod'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Yes'),
                        cancelButtonText: $translate.instant('No'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                        function (isConfirm) {
                            $timeout(function () {
                                if (isConfirm) {
                                    var isok = valueTypeValidation($scope.balanceInputList);
                                    defer.resolve(isok);
                                }
                                else {
                                    defer.resolve(false);
                                }
                            }, 300);
                        });

                    return defer.promise;
                }
                else {
                    $scope.isSelectPeriod = true;
                    var isSame = true;
                    $scope.balanceInputList.forEach(function (m) {
                        if (m.MonthId !== m.PeriodId.toString()) {
                            isSame = false;
                        }
                    });
                    if (isSame === false) { //是否只导入当前月份数据
                        swal({
                            title: "warning!",
                            text: $translate.instant('PeriodDifferenceTip'),
                            type: "warning",
                            showCancelButton: true,
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: $translate.instant('Yes'),
                            cancelButtonText: $translate.instant('No'),
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                            function (isConfirm) {
                                $timeout(function () {
                                    if (isConfirm) {
                                        var isOk = valueTypeValidation($scope.balanceInputList);
                                        defer.resolve(isOk);
                                    }
                                    else {
                                        defer.resolve(false);
                                    }
                                }, 300);
                            });
                        return defer.promise;
                    }
                    else {
                        var isOk = valueTypeValidation($scope.balanceInputList);
                        defer.resolve(isOk);
                        return defer.promise;
                    }
                }
            }



        }


        //获取要导入数据, 并通过期间过滤数据
        var getImportTbList = function (isSelect) {
            var importList = [];
            if (isSelect) {
                $scope.balanceInputList.forEach(function (m) {
                    if (filterImportData(m)) {
                        var balanceDto = {
                            'BalanceId': m.BalanceId,
                            'PeriodId': m.PeriodId,
                            'AcctCode': m.AcctCode,
                            'CustomerCode': m.CustomerCode,
                            'MonthId': m.PeriodId,
                            'BegDebitBal': m.BegDebitBal,
                            'BegCreditBal': m.BegCreditBal,
                            'DebitBal': m.DebitBal,
                            'CreditBal': m.CreditBal,
                            'EndDebitBal': m.EndDebitBal,
                            'EndCreditBal': m.EndCreditBal,
                            'BegBal': m.BegBal,
                            'EndBal': m.EndBal,
                        };
                        importList.push(balanceDto);
                    }
                });
            }
            else {
                $scope.balanceInputList.forEach(function (m) {
                    //VAT没有选择‘期间列’，所有导入数据的期间为$scope.period
                    //CIT没有选择‘期间列’，所有导入数据的期间为它本身的期间值
                    var tempPeriodId = $scope.serviceTypeId === constant.serviceType.VAT ? $scope.period : m.PeriodId
                    var balanceDto = {
                        'BalanceId': m.BalanceId,
                        'PeriodId': tempPeriodId,
                        'AcctCode': m.AcctCode,
                        'CustomerCode': m.CustomerCode,
                        'MonthId': null,
                        'BegDebitBal': m.BegDebitBal,
                        'BegCreditBal': m.BegCreditBal,
                        'DebitBal': m.DebitBal,
                        'CreditBal': m.CreditBal,
                        'EndDebitBal': m.EndDebitBal,
                        'EndCreditBal': m.EndCreditBal,
                        'BegBal': m.BegBal,
                        'EndBal': m.EndBal,
                    };
                    importList.push(balanceDto);
                });
            }
            if (importList.length === 0) {
                SweetAlert.warning($translate.instant('NoTbDataToImport'));
                return false;
            }
            else {
                $scope.toInputList = importList;
                return true;
            }

        }


        //根据PeriodId过滤数据
        var filterImportData = function (m) {
            var filterData = false;
            if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                filterData = m.MonthId === m.PeriodId
                    && m.PeriodId === $scope.period.toString();

            } else if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                filterData = m.MonthId === m.PeriodId;
            }

            return filterData;
        }


        //上传导入，并进行计算
        var importBalanceList = function (importType) {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportTrialBalance');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportTrialBalance');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportTrialBalance');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            vatImportService.importBalanceList($scope.toInputList, importType, $scope.serviceTypeId).success(function (rsp) {
                if (rsp.result) {
                    var queryImportDto = {
                        serviceTypeId: $scope.serviceTypeId,
                        periods: servicePeriods,
                        projectId: $scope.projectID,
                        importTypeId: enums.TbImportTypeEnum.TbImported
                    }

                    //修改项目状态
                    vatImportService.updatePeriodStatus(queryImportDto).success(function () {
                        refreshByService.refreshSuccess(enums.optionType.Import);
                        vatCommonService.importSetProjectStatus(projectDbName, $scope.period, constant.DictionaryDictKey.WFImportBalanceTable
                            , enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isTbImport, true);
                        $scope.fileName = '';
                        showTotalValue($scope.toInputList[0]);
                    });
                }
                else {
                    logDto.UpdateState = $translate.instant('ImportNotMatch');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.error($translate.instant('ImportNotMatch'));
                }
            }).error(function () {
                logDto.UpdateState = $translate.instant('ImportFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }


        //是否已经导入财务数据
        var isImportedErpData = function (importtype) {
            servicePeriods = [];
            if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                servicePeriods = [$scope.period];
            }
            else if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                servicePeriods = _.chain($scope.toInputList).map(function (item) { return item.PeriodId }).uniq().value();
            }

            var queryImportDto = {
                serviceTypeId: $scope.serviceTypeId,
                periods: servicePeriods,
                projectId: $scope.projectID
            }

            vatImportService.getProjectImportType(queryImportDto).success(function (re) {
                if (re.result) {
                    //var periods = _.chain($scope.toInputList).map(function (item) { return item.PeriodId }).uniq().value();
                    var importedErpData = _.find(re.data, function (item) { return item.importType === enums.projectImportType.ErpImported });
                    if (!_.isUndefined(importedErpData)) {
                        swal({
                            title: "warning!",
                            text: $translate.instant('ImportTypeTip'),
                            type: "warning",
                            showCancelButton: true,
                            confirmButtonText: $translate.instant('Yes'),
                            cancelButtonText: $translate.instant('No'),
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                            function (isConfirm) {
                                $timeout(function () {
                                    //清除财务数据
                                    if (isConfirm) {
                                        vatImportService.clearTableByPeriods(servicePeriods).success(function (re) {
                                            if (re.result && re.data) {
                                                importBalanceList(importtype);
                                            }
                                        }).error(function () {
                                            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                                        });
                                    }
                                }, 300);
                            });
                    }
                    else {
                        importBalanceList(importtype);
                    }
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };


        //导入事件
        var doUploadTbResult = function (importType) {
            if (vatSessionService.project.projectStatusList[$scope.period] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
                swal({
                    title: "warning!",
                    text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[$scope.period]) }),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                    function (isConfirm) {
                        $timeout(function () {
                            if (isConfirm) {
                                $log.debug("doUploadTbResult confirmed");
                                uploadTbResult(importType);
                            }
                            else {
                                swal.close();
                            }
                        }, 300);
                    });
            }
            else {
                uploadTbResult(importType);
            }

        }


        var uploadTbResult = function (importType) {
            if ($scope.sheetData.dataList.length == 0) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }

            //列名对应验证
            if (validationColumnMapping()) {
                //数据类型验证 
                validationTbData().then(function (isSuccess) {
                    if (isSuccess) {
                        //获取要导入的数据
                        if (getImportTbList($scope.isSelectPeriod)) {
                            //财务账提示
                            isImportedErpData(importType);
                        }
                    }
                });
            }
        }


        //显示图标
        var errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        }


        //显示明细
        var dealDetail = function () {
            return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">错误明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
        }


        //显示重复验证明细界面
        var dispalyduplicatedValidation = function (data) {
            $scope.detailData = data;
            $scope.dupColumns = [];
            $scope.dupColumns.push({
                caption: $translate.instant('AccountCode'),
                dataField: "AcctCode",
                width: 100
            });
            $scope.dupColumns.push({
                caption: $translate.instant('AccountName'),
                dataField: "AccountName",
                width: 120
            });
            if (data[0].MonthId !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('PeriodId'),
                    dataField: "MonthId",
                    width: 100
                });
            }
            if (data[0].BegBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('BegBal'),
                    dataField: "BegBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].BegDebitBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('BegDebitBal'),
                    dataField: "BegDebitBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].BegCreditBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('BegCreditBal'),
                    dataField: "BegCreditBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].DebitBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('DebitBal'),
                    dataField: "DebitBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].CreditBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('CreditBal'),
                    dataField: "CreditBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].EndDebitBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('EndDebitBal'),
                    dataField: "EndDebitBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].EndCreditBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('EndCreditBal'),
                    dataField: "EndCreditBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }
            if (data[0].EndBal !== null) {
                $scope.dupColumns.push({
                    caption: $translate.instant('EndBal'),
                    dataField: "EndBal",
                    format: { type: 'fixedPoint', precision: 2 },
                    width: 100
                });
            }

            $scope.filterCondition = ["IsDuplicate", "=", true];
            $scope.gridDuplicatedOptions = {
                allowColumnResizing: true,
                bindingOptions: {
                    "dataSource.store.data": "detailData",
                    //"selection.deferred": "deferStatus",
                    "selectionFilter": "filterCondition",
                    "columns": "dupColumns"
                },
                dataSource: { store: { type: "array", key: 'BalanceId' } },
                columns: $scope.dupColumns,
                selection: {
                    mode: "multiple",
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                    deferred: true
                },
                hoverStateEnabled: true,
                paging: { pageSize: 10 },
            }
            $('#duplicatedValidationModal').modal('show');
        }


        //显示本月与上月验证明细界面
        var dispalyPeriodValidation = function (data) {
            $scope.devgridDataSource = data;

            $scope.gridPeriodOptions = {
                columnAutoWidth: true,
                columns: [
                    {
                        caption: $translate.instant('AccountCode'),
                        dataField: "AcctCode",
                        textalign: "center",
                    },
                    {
                        caption: $translate.instant('LastMonth'),
                        alignment: 'center',
                        columns: [
                            {
                                caption: $translate.instant('EndBal'),
                                dataField: "EndBal",
                                format: { type: 'fixedPoint', precision: 2 },
                            },
                            {
                                caption: $translate.instant('EndDebitBal'),
                                dataField: "EndDebitBal",
                                format: { type: 'fixedPoint', precision: 2 },
                            },
                            {
                                caption: $translate.instant('EndCreditBal'),
                                dataField: "EndCreditBal",
                                format: { type: 'fixedPoint', precision: 2 },
                            },
                        ]
                    },
                    {
                        caption: $translate.instant('CurrentMonth'),
                        alignment: 'center',
                        columns: [
                            {
                                caption: $translate.instant('BegBal'),
                                dataField: "BegBal",
                                format: { type: 'fixedPoint', precision: 2 },

                            },
                            {
                                caption: $translate.instant('BegDebitBal'),
                                dataField: "BegDebitBal",
                                format: { type: 'fixedPoint', precision: 2 },
                            },
                            {
                                caption: $translate.instant('BegCreditBal'),
                                dataField: "BegCreditBal",
                                format: { type: 'fixedPoint', precision: 2 },
                            },
                        ]
                    },
                ],
                bindingOptions: {
                    "dataSource": "devgridDataSource"
                    //"dataSource.store.data": "devgridDataSource",
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }
            $('#periodValidationModal').modal('show');

        }


        //月份验证信息
        var openTab = function (errorType, rowdata) {
            var data = JSON.parse(rowdata);
            if (errorType === 31) {
                dispalyPeriodValidation(data);
            }
            else if (errorType === 39) {
                dispalyduplicatedValidation(data);
            }
        }


        //删除重复数据
        var deleteDupData = function () {
            var dataGrid = $('#gridDuplicatedValidation').dxDataGrid("instance");
            var deleteList = [];
            dataGrid.getSelectedRowsData().done(function (rowData) {
                for (var i = 0; i < rowData.length; i++) {
                    deleteList.push(rowData[i].AcctCode);
                }
            });
            dataGrid.getSelectedRowKeys().done(function (keys) {
                if (keys && keys.length === 0) {
                    SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                    return;
                }

                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = deleteList.join(",");
                logDto.OperationName = $translate.instant('DeleteDuplicateData');
                logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

                vatImportService.deleteDuplicateTbData(keys).success(function (rsp) {
                    if (rsp === true) {
                        logDto.UpdateState = $translate.instant('DeleteSuccess');
                        vatOperationLogService.addOperationLog(logDto);
                        refreshByService.callRefresh($scope.serviceTypeId, enums.optionType.DeleteDuplicate);
                    }
                    else {
                        logDto.UpdateState = $translate.instant('DeleteFailed');
                        vatOperationLogService.addOperationLog(logDto);
                    }

                }).error(function () {
                    logDto.UpdateState = $translate.instant('DeleteFailed');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            });
        }


        //刷新操作
        var refreshTbData = function () {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = '';
            logDto.OperationName = $translate.instant('RefreshValidationData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
            refreshByService.callRefresh($scope.serviceTypeId, enums.optionType.Refresh);
        }


        //开始清空数据
        var clearTbData = function () {
            if ($scope.serviceTypeId === constant.serviceType.CIT) {
                showPeriodDrapDown();
            }

            if ($scope.serviceTypeId === constant.serviceType.VAT) {
                $scope.selectedPeriod = $scope.period;
                deleteTbData();
            }

        };


        //清空数据
        var deleteTbData = function () {
            if ($scope.serviceTypeId === constant.serviceType.CIT
                && _.isNull($scope.selectedPeriod)) {
                SweetAlert.warning($translate.instant('SelectPeriodDelete'));
                return;
            }

            var alterMsg = $scope.serviceTypeId === constant.serviceType.CIT ? $translate.instant('ClearDataCITWarning')
                : $translate.instant('ClearDataVATWarning');

            swal({
                title: "warning!",
                text: alterMsg,
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
                function (isConfirm) {
                    $timeout(function () {
                        if (isConfirm) {
                            logDto.ID = PWC.newGuid();
                            logDto.CreateTime = new Date();
                            logDto.UpdateTime = new Date();
                            logDto.OperationContent = '';
                            logDto.OperationName = $translate.instant('ClearTrialBalance');
                            logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

                            var dto = {
                                serviceTypeId: $scope.serviceTypeId,
                                periods: [$scope.selectedPeriod],
                                projectId: $scope.projectID
                            }
                            vatImportService.clearServiceTbData(dto).success(function (data) {
                                if (data) {
                                    var queryImportDto = {
                                        serviceTypeId: $scope.serviceTypeId,
                                        periods: [$scope.selectedPeriod],
                                        projectId: $scope.projectID,
                                        importTypeId: enums.TbImportTypeEnum.UnImported
                                    }

                                    //修改项目状态
                                    vatImportService.updatePeriodStatus(queryImportDto).success(function () {
                                        $scope.selectedPeriod = null;
                                        if ($scope.serviceTypeId === constant.serviceType.CIT) {
                                            $scope.closePeriodSelectModal();
                                        }
                                        resetTotalValue();
                                        refreshByService.callRefresh($scope.serviceTypeId, enums.optionType.Clear);
                                        vatCommonService.clearProjectStatus(projectDbName, $scope.period, constant.DictionaryDictKey.WFImportBalanceTable
                                            , enums.FinishStatusEnum.NotFinished);
                                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isTbImport, false);
                                    });
                                }
                                else {
                                    $scope.selectedPeriod = null;
                                    if ($scope.serviceTypeId === constant.serviceType.CIT) {
                                        $scope.closePeriodSelectModal();
                                    }
                                    logDto.UpdateState = $translate.instant('ClearFailed');
                                    vatOperationLogService.addOperationLog(logDto);
                                    SweetAlert.warning($translate.instant('ClearFailed'));
                                }
                            }).error(function () {
                                logDto.UpdateState = $translate.instant('ClearFailed');
                                vatOperationLogService.addOperationLog(logDto);
                                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                            });
                        }
                        else {
                            return;
                        }
                    }, 300);
                });
        }


        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };


        var getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };


        //获取tb数据
        var GetBalanceList = function () {
            $scope.queryParams.pageInfo = {
                totalCount: $scope.pagingOptions.totalItems,
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                totalPage: 0,
            };

            vatImportService.queryTrialBalanceData($scope.queryParams).success(function (retData) {
                if (retData) {
                    var data = retData.list;
                    $scope.isShowImportTotalBtn = false;
                    GetValidationList();
                    initPagingControl(retData.pageInfo.totalCount);
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                        v.begDebitBal = PWC.round(v.begDebitBal, 2);
                        v.begCreditBal = PWC.round(v.begCreditBal, 2);
                        v.begBal = PWC.round(v.begBal, 2);
                        v.debitBal = PWC.round(v.debitBal, 2);
                        v.creditBal = PWC.round(v.creditBal, 2);
                        v.endDebitBal = PWC.round(v.endDebitBal, 2);
                        v.endCreditBal = PWC.round(v.endCreditBal, 2);
                        v.endBal = PWC.round(v.endBal, 2);
                    });
                    $scope.gridOptionsBalanceOuput.data = data;
                    $scope.totalData.totalNumber = retData.pageInfo.totalCount;
                    $scope.totalData.begDebitTotal = _.isNull(retData.calculateData.begDebitBal) ? PWC.round("0.00",2)   
                                                       : PWC.round(retData.calculateData.begDebitBal, 2);
                    $scope.totalData.begCreditTotal = _.isNull(retData.calculateData.begCreditBal) ? PWC.round("0.00", 2)
                                                       : PWC.round(retData.calculateData.begCreditBal, 2);
                    $scope.totalData.endDebitTotal = _.isNull(retData.calculateData.endDebitBal) ? PWC.round("0.00", 2)
                                                       : PWC.round(retData.calculateData.endDebitBal, 2);
                    $scope.totalData.endCreditTotal = _.isNull(retData.calculateData.endCreditBal) ? PWC.round("0.00", 2)
                                                      : PWC.round(retData.calculateData.endCreditBal, 2);
                    $scope.totalData.begBalTotal = _.isNull(retData.calculateData.begBal) ? PWC.round("0.00", 2)
                                                   : PWC.round(retData.calculateData.begBal, 2);
                    $scope.totalData.endBalTotal = _.isNull(retData.calculateData.endBal) ? PWC.round("0.00", 2)
                                                    : PWC.round(retData.calculateData.endBal, 2);
                    $scope.totalData.debitTotal = _.isNull(retData.calculateData.debitBal) ? PWC.round("0.00", 2)
                                                   : PWC.round(retData.calculateData.debitBal, 2);
                    $scope.totalData.creditTotal = _.isNull(retData.calculateData.creditBal) ? PWC.round("0.00", 2)
                                                    : PWC.round(retData.calculateData.creditBal, 2);
                    if (data.length > 0) {
                        initGridBalanceOuputColumn(data);
                    }
                    else {
                        initTableTitle();
                    }


                    $log.debug("获取数据成功");
                }

            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }


        //初始化columns
        var initGridBalanceOuputColumn = function (data) {
            $scope.gridOptionsBalanceOuput.columnDefs = [];
            $scope.gridOptionsBalanceOuput.columnDefs.push
                ({
                    name: $translate.instant('SequenceNo'), width: '5%', headerCellClass: '',
                    cellTemplate: '<div class="ui-grid-cell-contents " title="{{row.entity.index}}"><span>{{row.entity.index}}<span></div>'
                });

            if (data[0].monthId !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('PeriodId'), headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents " title="{{row.entity.monthId}}"><span>{{row.entity.monthId}}<span></div>'
                    });
            }

            if (data[0].customerCode !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('CustomerCode'), headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents " title="{{row.entity.customerCode}}"><span>{{row.entity.customerCode}}<span></div>'
                    });
            }

            if (data[0].acctCode !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('AccountCode'), headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.acctCode}}"><span>{{row.entity.acctCode}}<span></div>'
                    });
            }

            $scope.gridOptionsBalanceOuput.columnDefs.push(
                {
                    name: $translate.instant('AccountName'), headerCellClass: '',
                    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.accountName}}"><span>{{row.entity.accountName}}<span></div>'
                });
            if (data[0].begDebitBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('BegDebitBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.begDebitBal}}"><span>{{row.entity.begDebitBal}}<span></div>'
                    });
            }
            if (data[0].begCreditBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('BegCreditBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.begCreditBal}}"><span>{{row.entity.begCreditBal}}<span></div>'
                    });
            }
            if (data[0].begBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('BegBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.begBal}}"><span>{{row.entity.begBal}}<span></div>'
                    });
            }
            if (data[0].debitBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('DebitBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.debitBal}}"><span>{{row.entity.debitBal}}<span></div>'
                    });
            }
            if (data[0].creditBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('CreditBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.creditBal}}"><span>{{row.entity.creditBal}}<span></div>'
                    });
            }
            if (data[0].endDebitBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('EndDebitBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.endDebitBal}}"><span>{{row.entity.endDebitBal}}<span></div>'
                    });
            }
            if (data[0].endCreditBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('EndCreditBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.endCreditBal}}"><span>{{row.entity.endCreditBal}}<span></div>'
                    });
            }
            if (data[0].endBal !== null) {
                $scope.gridOptionsBalanceOuput.columnDefs.push(
                    {
                        name: $translate.instant('EndBal'), headerCellClass: 'right',
                        cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.endBal}}"><span>{{row.entity.endBal}}<span></div>'
                    });
            }

            showTotalValue(data[0]);

        };


        var initBalanceDataFromDB = function () {
            $scope.showInitTable = true;
            $scope.showImportTable = false;
            vatSessionService.dataChanged = false;
            $scope.gridOptionsBalanceOuput.data = [];
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            //判断当前导入数据类型
            vatImportService.isImportData($scope.projectID, enums.projectImportType.TbImported)
                .success(function (re) {
                    if (re.result) {
                        if (re.data) {
                            GetBalanceList();
                        } else {
                            initTableTitle();
                        }
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
        }


        //初始化列名
        var initTableTitle = function () {
            $scope.gridOptionsBalanceOuput.columnDefs = [];
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('SequenceNo'), headerCellClass: 'right', width: '5%',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('AccountCode'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('BegDebitBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begDebitBal}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('BegCreditBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begCreditBal}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('DebitBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.debitBal}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('CreditBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.creditBal}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('EndDebitBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.endDebitBal}}<span></div>'
            });
            $scope.gridOptionsBalanceOuput.columnDefs.push({
                name: $translate.instant('EndCreditBal'), headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.endCreditBal}}<span></div>'
            });
        }


        //获取验证信息
        var GetValidationList = function () {
            vatImportService.getServiceValidationList($scope.validationType, $scope.period, $scope.serviceTypeId, $scope.projectID).success(function (data) {
                if (data.length > 0) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = data;
                    $scope.gridOptionsErrorMsg.data = data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }


        //显示验证信息
        var toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');

                    $('#topIcon').css({ bottom: '-381px' });

                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };


        var setErrorWrapCssDefault = function () {
            $('#content-resizer').css('bottom', '0px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };


        var showErrTab = function() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "Nu__RequestVerificationTokenmberOfError": $scope.errorList.length });
        };


        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            uploadfile($scope.fileNameWrapper);
            //初始化数据
            $scope.selectedMappingList = [];
            initColumns();
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        }


        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };


        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        }


        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };


        //显示期间选择弹出框
        var showPeriodDrapDown = function () {
            $scope.modalInstance = $uibModal.open({
                animation: false,
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'tb-model-period-dropdown.html',
                scope: $scope,
                windowClass: "tb-model-period-dropdow-popup"
            });

            $scope.closePeriodSelectModal = function () {
                $scope.modalInstance.dismiss('cancel');
            };

            $scope.selectBox = {
                simple: {
                    dataSource: $scope.tbPeriods,
                    displayExpr: "Period",
                    valueExpr: "ID",
                    searchEnabled: false,
                    placeholder: $translate.instant('PleaseSelectPeriod'),
                    noDataText: $translate.instant('NoDataToDispaly'),
                    maxLength: 2,
                    onSelectionChanged: function (e) {
                        $scope.selectedPeriod = e.selectedItem.Period;
                    }
                }
            };

            vatImportService.getTBImportedPeriods($scope.projectID, $scope.serviceTypeId).success(function (data) {
                if (data) {
                    $scope.tbPeriods = [];
                    var id = 1;
                    $.each(data, function (index, item) {
                        var periodDto = { ID: -1, Period: -1 };
                        periodDto.ID = id++;
                        periodDto.Period = item;
                        $scope.tbPeriods.push(periodDto);
                    });

                    $("#tbPeriodSelectBox").dxSelectBox("instance").option("dataSource", $scope.tbPeriods);
                }

            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };


        //重置汇总数据为0
        var resetTotalValue = function () {
            if ($scope.serviceTypeId === constant.serviceType.VAT) {
                $scope.totalData.totalNumber = 0;
                $scope.totalData.begDebitTotal = 0;
                $scope.totalData.begCreditTotal = 0;
                $scope.totalData.endDebitTotal = 0;
                $scope.totalData.endCreditTotal = 0;
                $scope.totalData.begBalTotal = 0;
                $scope.totalData.endBalTotal = 0;
                $scope.totalData.debitTotal = 0;
                $scope.totalData.creditTotal = 0;
            }
        };


        //设置汇总数据的显示
        var showTotalValue = function (data) {
            $scope.showTotalValue.showBegDebitBal = !_.isNull(data.begDebitBal) ? true : false;
            $scope.showTotalValue.showBegCreditBal = !_.isNull(data.begCreditBal) ? true : false;
            $scope.showTotalValue.showEndDebitBal = !_.isNull(data.endDebitBal) ? true : false;
            $scope.showTotalValue.showEndCreditBal = !_.isNull(data.endCreditBal) ? true : false;
            $scope.showTotalSecondRow = $scope.showTotalValue.showBegDebitBal || $scope.showTotalValue.showBegCreditBal
                                      || $scope.showTotalValue.showEndDebitBal || $scope.showTotalValue.showEndCreditBal
                                       ? true : false;
           

        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        }

        var refreshByService = {
            //VAT刷新数据,重新计算
            vatRefresh: function (operation) {
                vatImportService.refreshTrialBalance($scope.period, $scope.serviceTypeId).success(function (data) {
                    if (data === true) {
                        refreshByService.refreshSuccess(operation);
                    }
                    else {
                        refreshByService.refreshFail();

                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            },

            //CIT刷新数据，重新计算
            citRefresh: function (operation) {
                vatImportService.getTBImportedPeriods($scope.projectID, $scope.serviceTypeId).success(function (data) {
                    if (!_.isUndefined(data)) {
                        var citImportedPeriods = [];
                        var id = 1;
                        $.each(data, function (index, item) {
                            citImportedPeriods.push(item);
                        });
                        var importDto = { periods: citImportedPeriods, serviceTypeId: $scope.serviceTypeId };
                        vatImportService.refreshTrialBalancePeriods(importDto)
                            .success(function (data) {
                                if (data) {
                                    refreshByService.refreshSuccess(operation);
                                }
                                else {
                                    refreshByService.refreshFail();
                                }
                            }).error(function () {
                                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                            });
                    }

                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                })
            },

            //只获取TB数据，不计算
            refreshSuccess: function (operation) {
                var successMsg = "";
                if (operation === enums.optionType.DeleteDuplicate) {
                    $('#duplicatedValidationModal').modal('hide');
                    successMsg = $translate.instant('DeleteSuccess');
                }

                if (operation === enums.optionType.Refresh) {
                    logDto.UpdateState = $translate.instant('RefreshSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('RefreshSuccess');
                }

                if (operation === enums.optionType.Clear) {
                    logDto.UpdateState = $translate.instant('ClearSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('ClearSuccess');
                }

                if (operation === enums.optionType.Import) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('ImportSuccess');
                }

                SweetAlert.success(successMsg);
                initBalanceDataFromDB();
            },

            refreshFail: function () {
                logDto.UpdateState = $translate.instant('RefreshTbFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('RefreshTbFail'));
            },

            callRefresh: function (serviceTypeId, operation) {
                if (serviceTypeId === constant.serviceType.VAT) {
                    refreshByService.vatRefresh(operation);
                }

                if (serviceTypeId === constant.serviceType.CIT) {
                    refreshByService.citRefresh(operation);
                }
            }

        };

        //开始
        (function initialize() {
            $log.debug('ImportTBController.ctor()...');
            checkUserOrganizationPermissionList();
            $scope.changeSheet = changeSheet;
            $scope.changeMapping = changeMapping;
            $scope.doUploadTbResult = doUploadTbResult;
            $scope.deleteDupData = deleteDupData;
            $scope.refreshTbData = refreshTbData;
            $scope.deleteTbData = deleteTbData;
            $scope.clearTbData = clearTbData;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.errorLevelToString = errorLevelToString;
            $scope.openTab = openTab;
            $scope.getGridHeight = getGridHeight;
            $scope.getErrorGridHeight = getErrorGridHeight;
            $scope.toggleErrorTab = toggleErrorTab;
            $scope.showOperateLogPop = showOperateLogPop;
            $scope.gridOptionsBalanceOuput = initGirdView.initBalanceOuput();
            $scope.gridOptionsErrorMsg = initGirdView.initErrorMsg();
            $scope.setGridStyle = setGridStyle;
            getUserPermission();
            initBalanceDataFromDB();
                         
          

            $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
                if (newValue !== null && newValue !== oldValue) {
                    initImportFile(newValue);
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);