﻿communityModule.controller('interactionTaxManageController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', '$state', 'vatSessionService',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, $state, vatSessionService) {
        'use strict';
        $scope.orderType = 0;
        $scope.essenceFlag = 0;
        $scope.titleSearch = '';

        //选择标签的事件
        var switchTab = function (e, type) {

            $(".share-filter-one").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            $scope.tagType = type;
            loadMainData();

        }


        //查询
        var loadMainData = function () {
            var config = {
                tag: $scope.tagType,
                essenceFlag: $scope.essenceFlag,
                orderType: $scope.orderType,
                title: $scope.titleSearch,
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                /*totalCount: $scope.pagingOptions.totalItems,
                totalPage: 0,*/
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/list', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.shareRecords = data.list;
                    initPagingControl(data.total);

                })
        };


        //查询标签
        var loadTagData = function (tag) {
            var config = {
                //3 是滴滴税管标签
                type: tag
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/getTagList', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.tags = data.data;

                })
        };

        //排序
        var switchOrderType = function (e, type) {
            $(".share-filter-two").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            $scope.orderType = type;
            loadMainData();

        }

        //精华帖排序
        var switchEssenceType = function (e, type) {
            $(".share-filter-three").removeClass("btn-vat-primary-share-warm");
            $(e.currentTarget).addClass("btn-vat-primary-share-warm");
            $scope.essenceFlag = type;
            loadMainData();

        }

        //标题搜索
        var searchByTitle = function () {
            loadMainData();
        }

        //详情
        var showDetail = function (item) {
            vatSessionService.project.taxShareId = item.id;
            vatSessionService.project.contentText = item.content;
            $state.go('interactionTaxManageDetail');
        }

        var loadTagData = function (tag) {
            var config = {
                //3 是滴滴税管标签
                type: tag
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/getTagList', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.tags = data.data;

                })
        };
        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[0], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[0].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        $scope.showTotalValue = {
            showBegDebitBal: false,
            showBegCreditBal: false,
            showEndDebitBal: false,
            showEndCreditBal: false
        };
        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };

        //新增
        var addTaxManage = function () {
            $scope.editType = 0;
            if ($scope.$editor == undefined) {
                $scope.$editor = $scope.editorInit('editor', 0);
            }
            setTimeout(function () {
                $scope.richText.write('');
            }, 200)

            $scope.title = '';
            $scope.tag = '';

            $('#postMessage').modal();
        }

        //编辑
        var editTaxManage = function (item) {
            vatSessionService.project.taxShareId = item.id;
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/' + item.id).then(
                function (data, status, headers) {

                    if ($scope.$editor == undefined) {
                        $scope.$editor = $scope.editorInit('editor', 0);
                    }
                    setTimeout(function () {
                        $scope.richText.write(data.data.content);
                    }, 200)

                    $scope.title = data.data.title;
                    $scope.tag = data.data.tag;
                    $scope.editType = 1;

                    $('#postMessage').modal();
                })


        };

        //新增编辑提交
        var postMessageSubmit = function () {
            if ($scope.richText.read().length <= 11) {
                SweetAlert.info("至少输入5个字");
                return false;
            }
            if ($scope.title == undefined ||$scope.title == '') {
                SweetAlert.info("请输入标题");
                return false;
            }
            if ($scope.tag == undefined ||$scope.title == '') {
                SweetAlert.info("请选择标签");
                return false;
            }
            var message = {
                content: $scope.richText.read(),
                title: $scope.title,
                tag: $scope.tag
            }
            if ($scope.editType == 0) {
                jqFetch.post(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/add', message).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.richText.write('');
                        $scope.title = '';
                        $scope.tag = '';
                        loadMainData();

                    })
            }
            else if ($scope.editType == 1) {
                message.id=vatSessionService.project.taxShareId;
                jqFetch.post(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/edit', message).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.richText.write('');
                        $scope.title = '';
                        $scope.tag = '';
                        loadMainData();

                    })
            }


        };



        (function initialize() {
            $scope.currentUser = vatSessionService.logUser.ID;
            $scope.loadMainData = loadMainData;
            $scope.switchOrderType = switchOrderType;
            $scope.switchEssenceType = switchEssenceType;
            $scope.searchByTitle = searchByTitle;
            $scope.showDetail = showDetail;
            $scope.switchTab = switchTab;
            $scope.editTaxManage = editTaxManage;
            $scope.addTaxManage = addTaxManage;
            $scope.postMessageSubmit = postMessageSubmit;
            $scope.loadTagData = loadTagData;
            $scope.tagClass = {
                all: 'btn-vat-primary-share',
            }
            loadMainData();
            loadTagData(3);
        })();
    }
]);