﻿﻿communityModule.controller('interactionTaxManageDetailController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', 'vatSessionService',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, vatSessionService) {
        'use strict';

        var loadDetail = function () {
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/' + vatSessionService.project.taxShareId, config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                    $scope.titleMessage = data.data.title;
                    $scope.isPraise = data.data.isPraise;
                    $scope.praiseNum = data.data.praiseNum;
                    $scope.showPraise = true;

                })

        };


        var loadCommend = function () {
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InteractionTaxManage/' + vatSessionService.project.taxShareId + '/commend', config).then(
                function (data, status, headers) {
                    $scope.commentRecords = data.data.commentRecords;
                })

        };
        var commentSend = function (type) {
            if (($scope.commentContent == undefined || $scope.commentContent == '') && type == 1) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            if ($scope.replyContent == '' && type == 2) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            var replyContent = '';
            var internationId = '';
            if (type == 1) {
                replyContent = $scope.commentContent
                internationId = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId
            }
            else if (type == 2) {
                replyContent = $scope.replyContent
                internationId = $scope.replyId
            }
            var config = {
                internationId: internationId,
                parentId: type == 2 ? $scope.parentId : '',
                parentUserId: type == 2 ? $scope.parentUserId : '',
                content: replyContent
            };
            $http.post('/InteractionTaxManage/comment/up', config, apiConfig.create()).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (type == 1) {
                        $scope.commentContent = '';
                    }
                    else if (type == 2) {
                        $(".replybox").remove();
                    }
                    loadCommend();
                })
        };

        var praise = function () {
                if ($scope.isPraise == 0) {
                    var config = {};
                    $http.post('/InteractionTaxManage/' + vatSessionService.project.taxShareId + '/vote/up', config, apiConfig.create()).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.isPraise = 1;
                        })
                }
                if ($scope.isPraise == 1) {
                    var config = {};
                    $http.post('/InteractionTaxManage/' + vatSessionService.project.taxShareId + '/vote/cancel', config, apiConfig.create()).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.isPraise = 0;
                        })
                }

            }

        ;(function initialize() {
            $scope.showPraise = false;
            loadDetail();
            $scope.showPraise = false;
            $scope.contentText = vatSessionService.project.contentText;
            $scope.contentSrc = vatSessionService.project.contentSrc;
            $scope.commentSend = commentSend;
            $scope.loadCommend = loadCommend;
            $scope.praise = praise;


        })();
    }
]);