﻿communityModule.controller('interacticeDetailController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', 'interactionService', '$stateParams', 'vatSessionService', '$state',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, interactionService, $stateParams, vatSessionService, $state) {
        'use strict';
        var commentSend = function (type) {
            if (($scope.commentContent == undefined || $scope.commentContent == '') && type == 1) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            if ($scope.replyContent == '' && type == 2) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            var replyContent = '';
            var internationId = '';
            if (type == 1) {
                replyContent = $scope.commentContent
                internationId = $stateParams.item.id
            }
            else if (type == 2) {
                replyContent = $scope.replyContent
                internationId = $scope.replyId
            }
            var config = {
                internationId: internationId,
                parentId: type == 2 ? $scope.parentId : '',
                parentUserId: type == 2 ? $scope.parentUserId : '',
                content: replyContent
            };
            $http.post('/Interactive/comment/up', config, apiConfig.create()).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (type == 1) {
                        $scope.commentContent = '';
                    }
                    else if (type == 2) {
                        $(".replybox").remove();
                    }
                    loadRecommend();
                })
        };

        var loadRecommend = function () {
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/' + $stateParams.item.id + '/commentList', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                })
        };

        var praise = function () {
            if ($scope.isPraise == 0) {
                var config = {};
                $http.post('/Interactive/' + vatSessionService.project.taxShareId + '/vote/up', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 1;
                    })
            }
            if ($scope.isPraise == 1) {
                var config = {};
                $http.post('/Interactive/' + vatSessionService.project.taxShareId + '/vote/cancel', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                    })
            }
        };
        /*kevin insert */
        var initAngular = function () {
            var dateFormat = 'yyyy-MM-dd';
            $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
            $scope.viewType = "";
            $scope.vote = {};
            $scope.message = {};
            $scope.task = {};
            $scope.dateBox = {
                beginTime: {
                    type: "date",
                    value: new Date(),
                    dateSerializationFormat: dateFormat,
                    displayFormat: dateFormat,
                    bindingOptions: {
                        'value': 'task.beginTime'
                    },
                    /*         width: '100%',*/
                    showClearButton: true,
                    placeholder: $scope.pleaseSelect
                },
                endTime: {
                    type: "date",
                    value: new Date(),
                    dateSerializationFormat: dateFormat,
                    displayFormat: dateFormat,
                    bindingOptions: {
                        'value': 'task.endTime'
                    },
                    /*width: '100%',*/
                    showClearButton: true,
                    placeholder: $scope.pleaseSelect
                }
            }
        }
        var itemId = null;
        var loadDetailInfo = function () {
            itemId = $stateParams.item.id;
            $scope._itemId = $stateParams.item.id;
            if ($stateParams.item.type == 1 || $stateParams.item.type == 2 || $stateParams.item.type == 3) {
                if ($stateParams.item.type == 3) {
                    reloadTicket();
                    $scope.viewType = 'vote';
                } else {
                    reloadInteractive();
                    $scope.viewType = 'message';
                }
            } else {
                $scope.viewType = 'task';
                loadTask($stateParams.item);
            }
        }
        var reloadInteractive = function () {
            interactionService.showDetail($stateParams.item.id).success(function (data) {
                if (data.resultMsg == 'success') {
                    $scope.message.contentText = data.data.content;
                    $scope.message.title = data.data.title;
                } else {
                    SweetAlert.error("获取详情信息失败,请与管理员联系");
                }
            });
        };

        var reloadTicket = function () {
            interactionService.showDetail($stateParams.item.id).success(function (res) {
                if (res.resultMsg == 'success') {
                    $scope.vote.contentText = res.data.content;
                    $scope.vote.title = res.data.title;
                    $scope.tickets = [];
                    var voteInfo = res.data.ticketInfo;//投票信息
                    $scope._sum = res.data.totalVote;
                    for (var i = 0; i < voteInfo.length; i++) {
                        $scope.tickets.push({
                            backgroundColor1: 'background-color: ' + getRandomColor(),
                            backgroundColor2: 'background-color: ' + getRandomColor() + "; display: inline-block;",
                            name: voteInfo[i].attrType,
                            percent: ((voteInfo[i].total / $scope._sum) * 100 / 5) + '%',
                            total: voteInfo[i].total
                        });
                    }
                    setTimeout(function () {
                        $scope.loadTicketPop();
                    }, 500);
                } else {
                    SweetAlert.error("获取详情信息失败,请与管理员联系");
                }
            });
        };
        var autoLoadTicket = function (list, isAdd) {
            if ($scope.tickets == undefined)
                return false;
            for (var i = 0; i < $scope.tickets.length; i++) {
                for (var m = 0, n = list.length; m < n; m++) {
                    if (isAdd) {
                        if ($scope.tickets[i].name == list[m].attrType) {
                            $scope.tickets[i].total++;
                            $scope._sum++;
                            $scope.tickets[i].percent = (($scope.tickets[i].total / ($scope._sum)) * 100 / 5) + '%';
                            break;
                        }
                        break;
                    } else {
                        if ($scope.tickets[i].name == list[m].attrType) {
                            $scope.tickets[i].total = list[m].total;
                            $scope.tickets[i].percent = ((list[m].total.total / (list[m].total._sum)) * 100 / 5) + '%';
                            break;
                        }
                    }
                }
                setTimeout(function () {
                    $scope.loadTicketPop(false);
                }, 500);
            }
        }

        //进行投票
        var subitTicket = function (vote) {
            var obj = {
                type: $stateParams.item.type,
                interactiveId: $stateParams.item.id,
                attrType: vote.name
            }
            interactionService.subitTicket(obj).success(function (res) {
                if (res.resultMsg == 'success') {
                    SweetAlert.success("投票成功");
                    var obj = [{attrType: vote.name, total: vote.total}];
                    autoLoadTicket(obj, true);
                } else {
                    SweetAlert.error(res.resultMsg);
                }
                //刷新投票信息
            });
        }
        var loadTicketPop = function (bool) {
            $('.skillbar').each(function () {
                var time = 0;
                if (bool == undefined || bool) {
                    time = 1000;
                } else {
                    time = 100
                }
                $(this).find('.skillbar-bar').animate({
                    width: $(this).attr('data-percent')
                }, time);
            });
        }

        /*****************************************************分割线********************************************************/

        function getRandomColor() {
            var color = {}
            color.r = Math.floor(Math.random() * 255);
            color.g = Math.floor(Math.random() * 255);
            color.b = Math.floor(Math.random() * 255);
            var color = 'rgba(' + color.r + ',' + color.g + ',' + color.b + ',0.8)';
            return color;
        }

        var setIntervalVote = function () {
            if (itemId == undefined) return false;
            jqFetch.setting("modal = false");
            setInterval(function () {
                jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/setIntervalVote?id=' + itemId).then(function (res, status, headers) {
                    var voteInfo = res.data.ticketInfo;//投票信息
                    var obj = [];
                    for (var i = 0; i < voteInfo.length; i++) {
                        obj.push({
                            attrType: voteInfo[i].attrType,
                            total: voteInfo[i].total,
                            _sum: res.data.totalVote
                        });
                    }
                    autoLoadTicket(obj, false);
                });
            }, 6000)
        }

        function $spread() {
            function initSpread(data) {
                var spreadNS = GC.Spread.Sheets;
                $scope.sheet = $scope.spread.getSheet(0);
                $scope.spread.suspendPaint();
                $scope.sheet.autoGenerateColumns = true;
                $scope.sheet.name("任务清单");
                $scope.sheet.options.protectionOptions = option;
                $scope.sheet.setArray(0, 0, dataFactory(data));
                initStyle();
                $scope.sheet.setColumnVisible(4, false);//隐藏id 列值
                $scope.spread.resumePaint();//ValueChanged
                $scope.sheet.bind(spreadNS.Events.CellDoubleClick, function (e, args) {
                    var row = args.row, col = args.col;
                    $scope.duringRow = row;
                    if ($scope.during == true) {
                        SweetAlert.info("其他工作人员正在操作文档，无法同时操作");
                        return false;
                    }
                    $scope.sheet.setValue(row, 1, "交互");
                    $scope.sheet.setValue(row, 2, $scope.duringCreateBy);
                    var d = new Date();
                    $scope.sheet.setValue(row, 3, d.formatDateTime('yyyy-MM-dd hh:mm:ss'));

                    //此时需要发送指定到后台，告诉系统当前正在操作
                    if ($stateParams.item.id != undefined) {
                        jqFetch.setting("modal = false");
                        jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/duringUpdate?id=' + $stateParams.item.id).then(function (res) {
                            if (res.resultMsg == "error") {
                                SweetAlert.error("duringUpdate请求失败");
                            } else {
                                $scope.duringOwn = true;
                            }
                        });
                    }
                    $scope.duringId = getValue(row, 4);///保存了操作的任务编号
                });
            };

            function dataFactory(data) {
                var dataArr = [["待解决事项", "模块", "创建人", "创建时间"]];
                for (var i = 0; i < data.length; i++) {
                    var arr = [];
                    arr.push(data[i].taskName);
                    arr.push("交互");
                    arr.push(data[i].createBy);
                    arr.push(data[i].createTime);
                    arr.push(data[i].id);//任务id
                    dataArr.push(arr);
                }
                return dataArr;
            };

            function loadSpreadJs() {
                $scope.spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss'), {sheetCount: 1});
            }

            function getValue(row, col) {
                $scope.sheet.getValue(row, col);
            }

            function setValue(row, col, value) {
                $scope.sheet.setValue(row, col, value);
            }

            function initStyle() {
                for (var i = 0; i <= 6; i++) {
                    $scope.sheet.setColumnWidth(i, 200);
                    var style = new GC.Spread.Sheets.Style();
                    style.font = "bold 15px/30px Georgia";
                    style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
                    style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
                    $scope.sheet.setStyle(0, i, style, GC.Spread.Sheets.SheetArea.viewport);
                }
            };

            function setData(data) {
                $scope.spread.suspendPaint();
                $scope.sheet.setArray(0, 0, dataFactory(data));
                $scope.spread.resumePaint();//ValueChanged
            };
            var option = {
                allowSelectLockedCells: true,
                allowSelectUnlockedCells: true,
                allowFilter: true,
                allowSort: false,
                allowResizeRows: true,
                allowResizeColumns: false,
                allowEditObjects: false,
                allowDragInsertRows: false,
                allowDragInsertColumns: false,
                allowInsertRows: false,
                allowInsertColumns: false,
                allowDeleteRows: false,
                allowDeleteColumns: false
            };
            return {
                initSpread: initSpread,
                loadSpreadJs: loadSpreadJs,
                setData: setData,
            }
        }

        var loadTask = function (item, reset) {
            interactionService.preLoadTask(item.id).success(function (res) {
                if (res.resultMsg != 'success') {
                    SweetAlert.error("任务预加载失败");
                }
                $scope.task.createBy = res.data.user.userName;
                $scope.duringCreateBy = res.data.user.userName;//当前执行人
                $scope.task.createTime = res.data.createTime;
                $scope.userData = res.data.userData;
                $scope.collaboratorList = res.data.collaboratorList;
                $scope.dataGridUpdate($scope.userData);
                var data = res.data.lists;
                $scope.task.pwcTasks = data;
                if (res.data.interactionInteractiveSystem != undefined && res.data.interactionInteractiveSystem != null) {
                    $scope.task = res.data.interactionInteractiveSystem;
                }
                //var data = [{taskName: "是否", type: "1221", createBy: '1212', createTime: '大是大非'}];
                $spread().loadSpreadJs();
                $spread().initSpread(data);
                //为了取消做准备的对象$scope.resetObj
                $scope.resetObj = angular.copy($scope.task);
                if (!reset && item.id != undefined) {
                    socket(true);
                }
            });
        };
        var PwcTask = function (taskName, createBy, beginTime, endTime, type, interactiveId, id) {
            this.taskName = taskName;
            this.createBy = createBy;
            this.beginTime = beginTime;
            this.endTime = endTime;
            this.type = type;
            this.interactiveId = interactiveId;
            this.id = id;
        }
        //保存任务
        $scope.taskSubmit = function () {
            if ($scope.task.title == '' || $scope.task.title == null || $scope.task.title == undefined) {
                SweetAlert.info("主任务标题不能为空");
                $('#task.title').focus();
                return false;
            }
            if ($scope.task.beginTime == undefined) {
                SweetAlert.info("任务起始时间不能为空");
                return false;
            }
            if ($scope.task.endTime == undefined) {
                SweetAlert.info("任务截止时间不能为空");
                return false;
            }
            if ($scope.task.beginTime >= $scope.task.endTime) {
                SweetAlert.info("任务起始时间不能大于截止时间");
                return false;
            }
            if ($scope.task.id == undefined) {//新增任务
                $scope.task.title = "[任务]" + $scope.task.title;
            }
            //构建子任务
            var childrenTasks = [];
            //taskName, createTime, createBy, beginTime, endTime, type, interactiveId
            var validate = true;
            for (var i = $scope.duringRow; i > 0; i--) {
                if ($scope.sheet.getValue(i, 0) == null) {
                    validate = false;
                    break;
                }
                childrenTasks.push(new PwcTask(
                    $scope.sheet.getValue(i, 0),
                    $scope.sheet.getValue(i, 2),
                    $scope.task.beginTime,
                    $scope.task.endTime,
                    4,
                    $scope.task.id,
                    $scope.sheet.getValue(i, 4)
                ));
            }
            if (validate == false) {
                SweetAlert.error("请正确填写任务清单");
                return false;
            }
            //$scope.task.pwcTasks = childrenTasks;
            $scope.task.nm = 0;
            delete $scope.task.createTime;
            $scope.task.pwcTasks = childrenTasks;
            interactionService.taskSubmit($scope.task).success(function (res) {
                if (res.resultMsg == "success") {
                    if ($stateParams.item.id == undefined) {
                        SweetAlert.success("任务添加成功");
                    } else {
                        SweetAlert.success("任务修改成功");
                    }
                    $scope.task.id = res.data.id;
                    if ($scope.collaboratorList == undefined) $scope.collaboratorList = [];
                } else {
                    SweetAlert.error("任务添加失败");
                }
            });
        }
        ;
        //取消
        $scope.taskReset = function () {
            //$spread().loadSpreadJs();
            /*   $spread().loadSpreadJs();
               $spread().initSpread(data);
               $spread().setData($scope.task.pwcTasks);*/
            $scope.sheet.suspendPaint();
            $scope.sheet.clear(0, 0, 200, 10, GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.StorageType.data);
            ;
            $spread().setData($scope.task.pwcTasks);
            $scope.sheet.resumePaint();//ValueChanged
            $scope.task = angular.copy($scope.resetObj);
            $scope.task.endTime = new Date($scope.task.beginTime.getTime() + 24 * 60 * 60 * 1000);
            $scope.duringRow = $scope.$scope.task.pwcTasks.length;
        }
        //返回
        $scope.goBack = function () {
            $state.go('internationalInteractive');
            socket(false).closeWebSocket();
        }
        //协同人弹框
        $scope.collaborator = function () {
            $('#collaborator').modal();
        }

        //导出任务列表
        $scope.exportData = function () {
            var excelIo = new GC.Spread.Excel.IO();
            var json = $scope.spread.toJSON();
            // here is excel IO API
            excelIo.save(json, function (blob) {
                saveAs(blob, $scope.task.title += '.xlsx');
            }, function (e) {
                console.log(e);
                SweetAlert.error("导出失败,请联系管理员");
            });
        };
        //协同人表格
        $scope.dataGridUpdate = function (_data) {
            $scope.userData = PWC.addIndex(_data);
            $scope.pagingOptions = {
                totalItems: _data.length,  //总数据
            };

            $scope.dataGridOptions = {
                bindingOptions: {
                    dataSource: 'userData',
                },
                height: 'auto',
                // repaintChangesOnly: true,
                // twoWayBindingEnabled: true,
                paging: {
                    enable: true,
                    pageIndex: 0,
                    pageSize: 5
                },
                pager: {
                    allowedPageSizes: 5,
                    infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                    showInfo: true,
                    showNavigationButtons: true,
                    showPageSizeSelector: true,
                    visible: true
                },
                showBorders: true,
                searchPanel: {//查询
                    highlightCaseSensitive: true,
                    highlightSearchText: true,
                    searchVisibleColumnsOnly: false,
                    text: "",
                    width: 518,
                    visible: true,
                    placeholder: $translate.instant('Search'),
                },
                sorting: {//排序
                    ascendingText: "Sort Ascending",
                    clearText: "Clear Sorting",
                    descendingText: "Sort Descending",
                    mode: "single"
                },
                showRowLines: true,
                columnAutoWidth: true,
                allowColumnReordering: true,
                columns: [
                    {
                        dataField: "xh",
                        caption: $translate.instant('ImportErrorPopUpNoCol'),
                        show: false,
                        allowHeaderFiltering: true,
                    },
                    {
                        dataField: "userName",
                        caption: $translate.instant('UserName'),
                        allowHeaderFiltering: true
                    },
                    {
                        dataField: "operation",
                        caption: $translate.instant('isOrNotAdd'),
                        allowHeaderFiltering: false,
                        width: 100,
                        textAlign: 'center',
                        cellTemplate: function (container, options) {
                            try {
                                var eventTarget = $('<div class="dx-field">' +
                                    '                    <div class="dx-field-value"> <input type = "hidden" name ="dataId" value = "' + options.data.ID + '">' +
                                    '                        <div class="checked" ></div>' +
                                    '                    </div>' +
                                    '                </div>');
                                eventTarget.off('click').on('click', function () {
                                });
                                container.append(eventTarget);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                ],
                rowAlternationEnabled: true,  //单双行颜色
                onContentReady: function (e) {
                    var checkboxs = $(".checked").dxCheckBox({
                        text: "添加",
                        onValueChanged: function (e) {
                            var selectValue = e.component._$element.prev().attr('value');
                            if (e.value == true) {
                                if ($scope.task.id == undefined) {
                                    SweetAlert.info("请先保存任务");
                                    e.component._$element.removeClass('dx-checkbox-checked')
                                    return false;
                                }
                                $scope.collaboratorList.push(selectValue);
                            } else {
                                var _index = $scope.collaboratorList.indexOf(selectValue);
                                $scope.collaboratorList.splice(_index, 1);
                                e.component._$element.removeClass('dx-checkbox-checked')
                            }
                        },
                        width: '80px'
                    }).dxCheckBox("instance");
                    if ($scope.collaboratorList != undefined) {
                        for (var i = 0; i < $scope.collaboratorList.length; i++) {
                            $('.checked').each(function (index, ele) {
                                if ($(this).prev().val() == $scope.collaboratorList[i]) {
                                    $(this).addClass('dx-checkbox-checked');
                                    return false;
                                }
                            });
                        }
                    }
                    ;
                }
            };
        };


        //提交写同人
        $scope.collaboratorSumbit = function () {
            if ($scope.collaboratorList.length == 0) {
                SweetAlert.info("请选择协同人");
                return false;
            }
            if ($scope.task.id == undefined) {
                SweetAlert.info("请先保存任务");
                return false;
            }
            var obj = {
                attachUrl: $scope.collaboratorList.toString(),
                id: $scope.task.id
            }
            interactionService.collaboratorSumbit(obj).success(function (res) {
                    if (res.resultMsg == 'success') {
                        SweetAlert.success("操作成功");
                    } else {
                        SweetAlert.error("操作成功");
                    }
                }
            );
        }
        var websocket = null;

        function socket(bool) {
            if (bool) {
                //var tocken = apiInterceptor.apiToken();
                var username = $scope.task.createBy; // 获得当前登录人员
                //判断当前浏览器是否支持WebSocket
                if ('WebSocket' in window) {
                    //var host = apiInterceptor.vatWebApiHostUrl;
                    //host.split("/");
                    websocket = new WebSocket('ws://127.0.0.1:8180/websocket' + '/' + username + /checkStatus/ + $stateParams.item.id);
                } else {
                    SweetAlert.error("当前浏览器 Not support websocket'");
                }
                //连接发生错误的回调方法
                websocket.onerror = function () {
                    SweetAlert.error("WebSocket连接发生错误");
                };

                //连接成功建立的回调方法
                websocket.onopen = function () {
                    console.log("WebSocket连接成功")
                }

                //接收到消息的回调方法
                websocket.onmessage = function (event) {
                    var resBody = JSON.parse(event.data);
                    if (resBody.checkStatus == '1' && $scope.duringOwn == true) {
                        /*$scope.during = false;
                        $scope.sheet.suspendPaint();
                        $scope.sheet.options.isProtected = false;
                        $scope.sheet.resumePaint();*/
                    } else if (resBody.checkStatus == '1' && $scope.duringOwn == undefined) {
                        $scope.during = true;
                        $scope.sheet.suspendPaint();
                        $scope.sheet.options.isProtected = true;
                        $scope.sheet.resumePaint();
                    } else if (resBody.checkStatus == '0') {
                        $scope.during = false;
                        $scope.sheet.suspendPaint();
                        $scope.sheet.options.isProtected = false;
                        $scope.sheet.resumePaint();
                    } else {
                        $scope.task.pwcTasks = resBody.pushTaskInfo;
                        $scope.sheet.clear(0, 0, 200, 10, GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.StorageType.data);
                        $spread().setData($scope.task.pwcTasks);
                        /*$scope.spread.destory();
                        $spread().loadSpreadJs();
                        $spread().initSpread($scope.task.pwcTasks);*/
                    }
                }

                //连接关闭的回调方法
                websocket.onclose = function () {
                    console.log("websocket连接关闭");
                }
                //监听窗口关闭事件，当窗口关闭时，主动去关闭websocket连接，防止连接还没断开就关闭窗口，server端会抛异常。
                window.onbeforeunload = function () {
                    websocket.close();
                }
            }

            //关闭WebSocket连接
            function closeWebSocket() {
                if (websocket != null) {
                    websocket.close();
                }
            }

            return {
                closeWebSocket: closeWebSocket
            }
                ;
        }

        ;(function initialize() {
            $scope.showPraise = false;
            $scope.showPraise = false;
            $scope.commentSend = commentSend;
            $scope.praise = praise;
            $scope.loadDetailInfo = loadDetailInfo;
            $scope.subitTicket = subitTicket;
            $scope.loadTicketPop = loadTicketPop;
            initAngular();
            loadDetailInfo();
            loadRecommend();
            if ($stateParams.item.type == 3) setIntervalVote();

        })();
    }
]);