﻿﻿communityModule.controller('taxShareController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', '$state', 'vatSessionService',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, $state, vatSessionService) {
        'use strict';
        $scope.orderType = 0;
        $scope.essenceFlag = 0;
        $scope.titleSearch = '';

        var switchTab = function (e, type) {

            $(".share-filter-one").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            $scope.tagType = type;
            loadMainData();

        }

        var switchTagTab = function (e, type) {
            $(".share-filter-one").removeClass("btn-vat-primary-share");
            $scope.tagClass = {};
            $scope.tagClass[type] = 'btn-vat-primary-share';
            $scope.tagType = type;
            loadMainData();

        }

        var loadMainData = function () {
            var config = {
                tagType: $scope.tagType,
                essenceFlag: $scope.essenceFlag,
                orderType: $scope.orderType,
                title: $scope.titleSearch,
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                /*totalCount: $scope.pagingOptions.totalItems,
                totalPage: 0,*/
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/taxEmail/list', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.shareRecords = data.list;
                    initPagingControl(data.total);

                })
        };

        var loadTagData = function (tag) {
            var config = {
                //1 是税享标签
                type: tag
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InternationSystem/getTagList', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.tags = data.data;

                })
        };


        var switchOrderType = function (e, type) {
            $(".share-filter-two").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            $scope.orderType = type;
            loadMainData();

        }

        var switchEssenceType = function (e, type) {
            $(".share-filter-three").removeClass("btn-vat-primary-share-warm");
            $(e.currentTarget).addClass("btn-vat-primary-share-warm");
            $scope.essenceFlag = type;
            loadMainData();

        }

        var searchByTitle = function () {
            loadMainData();
        }

        var showDetail = function (item) {
            vatSessionService.project.taxShareId = item.id;
            vatSessionService.project.shareType = item.type;
            if (item.type == 1) {
                vatSessionService.project.contentText = item.content;
            }
            else if (item.type == 0) {
                vatSessionService.project.contentSrc = item.url;
            }

            $state.go('taxShareDetail');
            /*  window.open('/sharedetail', '_blank');*/
        }
        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[0], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[0].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        $scope.showTotalValue = {
            showBegDebitBal: false,
            showBegCreditBal: false,
            showEndDebitBal: false,
            showEndCreditBal: false
        };
        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        (function initialize() {
            $scope.loadMainData = loadMainData;
            $scope.switchOrderType = switchOrderType;
            $scope.switchEssenceType = switchEssenceType;
            $scope.searchByTitle = searchByTitle;
            $scope.showDetail = showDetail;
            $scope.switchTab = switchTab;
            $scope.switchTagTab = switchTagTab;
            $scope.tagClass = {
                all: 'btn-vat-primary-share',
            }
            loadMainData();
            loadTagData(1);
            /*  var height = $(window).height();
              $(".share-content").height(height);*/
        })();
    }
]);