﻿﻿communityModule.controller('taxShareDetailController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', 'vatSessionService', '$stateParams', '$state',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, vatSessionService, $stateParams, $state) {
        'use strict';

        var loadCommennd = function () {
            var config = {};
            var id = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId;
            jqFetch.get(apiInterceptor.webApiHostUrl + '/taxEmail/' + id + '/loadCommends', config).then(
                function (data, status, headers) {
                    $scope.commentRecords = data.data.commentRecords;
                })
        };

        var loadDetail = function () {
            var config = {};
            var id = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId;
            jqFetch.get(apiInterceptor.webApiHostUrl + '/taxEmail/' + id, config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                    $scope.titleMessage = data.data.title;
                    $scope.isPraise = data.data.isPraise;
                    $scope.praiseNum = data.data.praiseNum;
                    $scope.showPraise = true;
                    jqFetch.get(apiInterceptor.webApiHostUrl + '/taxEmail/showIframeUrl?url=' + data.data.url, config).then(function (response) {
                        //var  response= JSON.parse(JSON.stringify(response));
                        //var newWin = window.open('', '_blank');
                        //newWin.document.write(response);
                        // $('#tax-share-url').attr("srcdoc", response);;
                        document.getElementById('tax-share-url').contentWindow.document.write(response)
                        setTimeout(function () {
                            $('#tax-share-url').height($(window.frames["iframeName"].document).find("body").height());
                            $('#tax-share-url').css('display', "block");
                        }, 400)
                    });
                })
        };


        var commentSend = function (type) {
            if (($scope.commentContent == undefined || $scope.commentContent == '') && type == 1) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            if ($scope.replyContent == '' && type == 2) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            var replyContent = '';
            var emailId = '';
            if (type == 1) {
                replyContent = $scope.commentContent
                emailId = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId
            }
            else if (type == 2) {
                replyContent = $scope.replyContent
                emailId = $scope.replyId
            }
            var config = {
                emailId: emailId,
                parentId: type == 2 ? $scope.parentId : '',
                parentUserId: type == 2 ? $scope.parentUserId : '',
                content: replyContent
            };
            $http.post('/taxEmail/comment/up', config, apiConfig.create()).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (type == 1) {
                        $scope.commentContent = '';
                    }
                    else if (type == 2) {
                        $(".replybox").remove();
                    }
                    loadCommennd();
                })
        };

        var praise = function () {
            if ($scope.isPraise == 0) {
                var config = {};
                $http.post('/taxEmail/' + $scope.taxShareId + '/vote/up', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 1;
                    })
            }
            if ($scope.isPraise == 1) {
                var config = {};
                $http.post('/taxEmail/' + $scope.taxShareId + '/vote/cancel', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 0;
                    })
            }
        };
        var loadData = function () {
                if ($stateParams.item == undefined || $stateParams.item == null) {
                    return;
                } else {
                    $scope.shareType = $stateParams.item.type;
                    $scope.contentText = $stateParams.item.content;
                    $scope.contentSrc = $stateParams.item.url;
                }
            }

        ;(function initialize() {
            $scope.taxShareId = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId;
            loadDetail();
            $scope.showPraise = false;
            $scope.shareType = vatSessionService.project.shareType;
            $scope.contentText = vatSessionService.project.contentText;
            $scope.contentSrc = vatSessionService.project.contentSrc;
            $scope.commentSend = commentSend;
            $scope.loadCommennd = loadCommennd;
            $scope.praise = praise;
            loadData();
        })();
    }
]);