﻿﻿communityModule.controller('taxShareInteractiveController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', '$state', 'interactionService',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, $state, interactionService) {
        'use strict';
        $scope.orderType = 0;
        $scope.essenceFlag = 0;
        $scope.titleSearch = '';
        var loadMainData = function () {
            var config = {
                essenceFlag: $scope.essenceFlag,
                orderType: $scope.orderType,
                title: $scope.titleSearch,
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                /*totalCount: $scope.pagingOptions.totalItems,
                totalPage: 0,*/
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/listData', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.shareRecords = data.data.list;
                    initPagingControl(data.data.total);
                })
        };

        var switchOrderType = function (e, type) {
            $(".share-filter-two").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            $scope.orderType = type;
            loadMainData();

        }

        var switchEssenceType = function (e, type) {
            $(".share-filter-three").removeClass("btn-vat-primary-share-warm");
            $(e.currentTarget).addClass("btn-vat-primary-share-warm");
            $scope.essenceFlag = type;
            loadMainData();
        }

        /***********************************************kevin insert*****************************************/
        var switchOperation = function (e, type) {
            switch (type) {
                case 1:
                    caseType1(e)
                    break;
                case 2:
                    caseType2(e)
                    break;
                case 3:
                    caseType3(e)
                    break;
                case 4:
                    caseType4(e)
                    break;
            }
        }
        var caseType1 = function () {//发布留言
            if ($scope.$editor == undefined) {
                $scope.$editor = $scope.editorInit('editor', 0);
            }
            $('#postMessage').modal();
        }
        var caseType2 = function () {//发布提问
            if ($scope.$editor1 == undefined) {
                $scope.$editor1 = $scope.editorInit('editor1', 1);
            }
            $('#postQuestion').modal();
        }
        setTimeout(function () {
            $scope._tag.emptyContent();
            $scope._tag.addTagsContent("<input type=\"text\" id=\"tag1\" > ");
            $scope._tag.inputDoms = ['tag1'];
            $scope.$tags = $scope._tag.init();
        }, 300);
        var caseType3 = function () {//发起投票
            if ($scope.$editor2 == undefined) {
                $scope.$editor2 = $scope.editorInit('editor2', 2);
            }
            $('#postvote').modal();
        }
        var caseType4 = function () {//发布任务
            $state.go('interacticeDetail', {item: {type : 4}});
        }
        var postMessageSubmit = function () {
            if ($scope.richText.read().length <= 11) {
                SweetAlert.info("至少输入5个字");
                return false;
            }
            if ($scope.postMessage == undefined || $scope.postMessage.title == undefined) {
                SweetAlert.info("请输入标题");
                return false;
            }
            var message = {
                content: $scope.richText.read(),
                nm: $scope.postMessage.nm ? 1 : 0,
                title: '[留言]' + $scope.postMessage.title
            }
            interactionService.postMessageSubmit(message).success(function (res) {
                if (res.resultMsg == "success") {
                    SweetAlert.success("添加成功");
                } else {
                    SweetAlert.error("添加失败");
                }
                //清空编辑器和tag数据
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                $scope.postMessage = '';
                loadMainData();
            });
        }
        var postQuestionSubmit = function () {
            if ($scope.richText.read().length <= 11) {
                SweetAlert.info("至少输入5个字");
                return false;
            }
            if ($scope.postQuestion == undefined || $scope.postQuestion.title == undefined) {
                SweetAlert.info("请输入标题");
                return false;
            }
            var message = {
                content: $scope.richText.read(),
                title: '[提问]' + $scope.postQuestion.title,
                nm: $scope.postQuestion.nm ? 1 : 0
            }
            interactionService.postQuestion(message).success(function (res) {
                if (res.resultMsg == "success") {
                    SweetAlert.success("添加成功");
                } else {
                    SweetAlert.error("添加失败");
                }
                //清空编辑器和tag数据
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                $scope._tag.emptyContent();
                $scope.postQuestion.title = '';
                loadMainData();
            });
        }
        var postVoteSubmit = function () {
            if ($scope.richText.read().length <= 11) {
                SweetAlert.info("至少输入5个字");
                return false;
            }
            if ($scope.postVote == undefined || $scope.postVote.title == undefined) {
                SweetAlert.info("请输入标题");
                return false;
            }
            var message = {
                content: $scope.richText.read(),
                title: '[投票]' + $scope.postVote.title,
                tag: JSON.stringify($scope._tag.getValueById('#tag1'))
            }
            interactionService.postVoteSubmit(message).success(function (res) {
                if (res.resultMsg == "success") {
                    SweetAlert.success("添加成功");
                } else {
                    SweetAlert.error("添加失败");
                }
                $scope.postVote = '';
                loadMainData();
            });
        }
        var hideModel = function () {
            $('#postMessage').on('hidden.bs.modal', function (e) {
                //清空编辑器和tag数据
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                $scope.postMessage = {};
            })
            $('#postQuestion').on('hidden.bs.modal', function (e) {
                //清空编辑器和tag数据
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                $scope.postQuestion = {};
            })
            $('#postvote').on('hidden.bs.modal', function (e) {
                //清空编辑器和tag数据
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                $scope._tag.emptyContent();
                $scope.postVote = {};
            })

        }


        var postTaskSubmit = function () {

        }
        var switchTab = function (e, type) {
            $("._share-filter-two").removeClass("btn-vat-primary-share");
            $(e.currentTarget).addClass("btn-vat-primary-share");
            var config = {
                essenceFlag: $scope.essenceFlag,
                orderType: $scope.orderType,
                title: $scope.titleSearch ? $scope.titleSearch : '',
                pageIndex: $scope.pagingOptions.pageIndex,
                pageSize: $scope.pagingOptions.pageSize,
                /*totalCount: $scope.pagingOptions.totalItems,
                totalPage: 0,*/
            };
            jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/getListByType?type=' + type, config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (data.resultMsg == "success") {
                        $scope.shareRecords = data.data.list;
                        initPagingControl(data.data.total);
                    } else {
                        SweetAlert.error("数据获取失败,请联系管理员");
                    }
                })
        }
        var showDetail = function (item) {
            $state.go('interacticeDetail', {item: item});
        }
        /***********************************************insert end *****************************************/

        var searchByTitle = function () {
            loadMainData();
        }

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[0], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[0].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        $scope.showTotalValue = {
            showBegDebitBal: false,
            showBegCreditBal: false,
            showEndDebitBal: false,
            showEndCreditBal: false
        };
        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        (function initialize() {
            $scope.loadMainData = loadMainData;
            $scope.switchOrderType = switchOrderType;
            $scope.switchOperation = switchOperation;
            $scope.switchEssenceType = switchEssenceType;
            $scope.postVoteSubmit = postVoteSubmit;
            $scope.postTaskSubmit = postTaskSubmit;
            $scope.postMessageSubmit = postMessageSubmit;
            $scope.searchByTitle = searchByTitle;
            $scope.showDetail = showDetail;
            $scope.postQuestionSubmit = postQuestionSubmit;
            $scope.switchTab = switchTab;
            loadMainData();
            hideModel();
            var height = $(window).height();
            $(".share-content").height(height);
        })();
    }
]);