﻿communityModule.controller('taxShareInteractiveDetailController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', 'vatSessionService',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, vatSessionService) {
        'use strict';

        var loadRecommend = function () {
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/Interactive/' + vatSessionService.project.taxShareId, config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                    $scope.isPraise = data.data.isPraise;
                    $scope.praiseNum = data.data.praiseNum;
                    $scope.showPraise = true;
                    /*$('#tax-share-url').attr('src', $scope.contentSrc).show().on('load', function () {

                    });*/
                    var height = $(window).height();

                    $('#tax-share-url').height(500);

                })

        };

        var commentSend = function (type) {
            if (($scope.commentContent == undefined || $scope.commentContent == '') && type == 1) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            if ($scope.replyContent == '' && type == 2) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            var replyContent = '';
            var emailId = '';
            if (type == 1) {
                replyContent = $scope.commentContent
                emailId = vatSessionService.project.taxShareId
            }
            else if (type == 2) {
                replyContent = $scope.replyContent
                emailId = $scope.replyId
            }
            var config = {
                emailId: emailId,
                parentId: type == 2 ? $scope.parentId : '',
                parentUserId: type == 2 ? $scope.parentUserId : '',
                content: replyContent
            };
            $http.post('/Interactive/comment/up', config, apiConfig.create()).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (type == 1) {
                        $scope.commentContent = '';
                    }
                    else if (type == 2) {
                        $(".replybox").remove();
                    }
                    loadRecommend();
                })
        };

        var praise = function () {
            if ($scope.isPraise == 0) {
                var config = {};
                $http.post('/Interactive/' + vatSessionService.project.taxShareId + '/vote/up', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 1;
                    })
            }
            if ($scope.isPraise == 1) {
                var config = {};
                $http.post('/Interactive/' + vatSessionService.project.taxShareId + '/vote/cancel', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 0;
                    })
            }

        };

        (function initialize() {
            $scope.showPraise = false;
            loadRecommend();
            $scope.showPraise = false;
            $scope.shareType = vatSessionService.project.shareType;
            $scope.contentText = vatSessionService.project.contentText;
            $scope.contentSrc = vatSessionService.project.contentSrc;
            $scope.commentSend = commentSend;
            $scope.loadRecommend = loadRecommend;
            $scope.praise = praise;


        })();
    }
]);