﻿communityModule.controller('taxShareInternationalDetailController', ['$scope', '$filter', '$log', '$translate', '$http', 'SweetAlert',
    'apiConfig', 'jqFetch', 'apiInterceptor', 'vatSessionService', 'interactionService', '$stateParams',
    function ($scope, $filter, $log, $translate, $http, SweetAlert, apiConfig, jqFetch, apiInterceptor, vatSessionService, interactionService, $stateParams) {
        'use strict';

        var loadDetail = function (type) {
            var id = null;
            if ($stateParams.id != null || $stateParams.id != undefined) {
                id = $stateParams.id;
            } else {
                id = vatSessionService.project.taxShareId
            }
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InternationSystem/' + id, config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                    $scope.titleMessage = data.data.title;
                    $scope.attachUrl = data.data.attachUrl;
                    $scope.isPraise = data.data.isPraise;
                    $scope.praiseNum = data.data.praiseNum;
                    $scope.showPraise = true;
                    $scope.showPdf = true;
                    if ($scope.showPdf && $scope.shareType == 1 && type != 1) {
                        pdfView();
                    }

                })

        };

        var loadCommend = function () {
            var id = null;
            if ($stateParams.id != null || $stateParams.id != undefined) {
                id = $stateParams.id;
            } else {
                id = vatSessionService.project.taxShareId
            }
            var config = {};
            jqFetch.get(apiInterceptor.webApiHostUrl + '/InternationSystem/' + id + '/commend', config).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.commentRecords = data.data.commentRecords;
                })

        };

        var commentSend = function (type) {

            if (($scope.commentContent == undefined || $scope.commentContent == '') && type == 1) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            if ($scope.replyContent == '' && type == 2) {
                SweetAlert.warning('请填写回复内容');
                return;
            }
            var replyContent = '';
            var internationId = '';
            if (type == 1) {
                replyContent = $scope.commentContent
                internationId = vatSessionService.project.taxShareId == undefined ? $stateParams.item.id : vatSessionService.project.taxShareId
            }
            else if (type == 2) {
                replyContent = $scope.replyContent
                internationId = $scope.replyId
            }
            var config = {
                internationId: internationId,
                parentId: type == 2 ? $scope.parentId : '',
                parentUserId: type == 2 ? $scope.parentUserId : '',
                content: replyContent
            };
            $http.post('/InternationSystem/comment/up', config, apiConfig.create()).then(
                function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    if (type == 1) {
                        $scope.commentContent = '';
                    }
                    else if (type == 2) {
                        $(".replybox").remove();
                    }
                    loadCommend();
                })
        };

        var praise = function () {
            if ($scope.isPraise == 0) {
                var config = {};
                $http.post('/InternationSystem/' + vatSessionService.project.taxShareId + '/vote/up', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 1;
                    })
            }
            if ($scope.isPraise == 1) {
                var config = {};
                $http.post('/InternationSystem/' + vatSessionService.project.taxShareId + '/vote/cancel', config, apiConfig.create()).then(
                    function (data, status, headers) {
                        if (status === 204) {
                            SweetAlert.warning("没有数据");
                            return;
                        }
                        $scope.isPraise = 0;
                    })
            }

        };

        function start() {
            return new Promise(function (resolve, reject) {
                resolve('start');
            });
        };

        var pdfView = function () {

            start().then(function (start) {
                return interactionService.getRemotePdfUrl($scope.attachUrl);
            }).then(function (res) {
                if (res.data == null) {
                    SweetAlert.warning("pdf加载失败");
                    return;
                }
                $scope.openPdfPreviewPop(res.data)
            })
        };


        (function initialize() {
            $scope.showPraise = false;
            $scope.shareType = vatSessionService.project.shareType;
            loadDetail();
            $scope.contentText = vatSessionService.project.contentText;
            $scope.contentSrc = vatSessionService.project.contentSrc;
            $scope.commentSend = commentSend;
            $scope.loadDetail = loadDetail;
            $scope.praise = praise;
            $scope.pdfView = pdfView;
        })();
    }
]);