﻿vatModule.controller('VatPreviewTrialBalanceEndPeriodController', ['$rootScope','$scope','$filter','$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope,$filter, $log,$translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        //所有启始月份为当年一月
        $scope.startMonth =vatSessionService.year * 100 + 1;
        $scope.endMonth = vatSessionService.year * 100 + vatSessionService.month;
        $scope.monthEnd=vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;
        $scope.pageSize = constant.vatPagesize;

        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        $scope.monthList = [1,2,3,4,5,6,7,8,9,10,11,12,13];

        //初始化期间
        var initPeriods = function () {

            var curMonth = new Date().getMonth() + 1;

            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                orgId: '',
                segment3 : null,
                segment3Name : null,
                segment5 : null,
                segment5Name : null,
                segment6 : null,
                segment6Name : null,
            };
        };

        //从数据库中load数据
        var loadTrialBalanceDataFromDB = function (pageIndex) {
            initTrialBalancePagination();
            $scope.curTrialBalancePage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryTrialBalanceResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryTrialBalanceResult.pageInfo.pageSize,
                totalPage: 0
            };

            $scope.queryParams.orgId = vatSessionService.project.organizationID;

            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            vatPreviewService.getTBEndPeriodDataForDisplay(queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryTrialBalanceResult.pageInfo = data;
                    computeTrialBalancePage();
                    $scope.ledgerName = data.list[0].ledgerName;
                    $scope.currencyCode = data.list[0].currencyCode;
                    $scope.status = data.list[0].status;
                    $scope.importDate = $filter('date')(data.list[0].createTime, "yyyy-MM-dd HH:mm:ss");
                }
            });
        };


        //点击任意一页加载数据事件
        var loadIncomeInvoiceDataByPage = function (pageIndex) {
            loadTrialBalanceDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeTrialBalancePage = function () {

            if ($scope.queryTrialBalanceResult.pageInfo && $scope.queryTrialBalanceResult.pageInfo.total > 0) {

                var totalPage = parseInt($scope.queryTrialBalanceResult.pageInfo.total / $scope.pageSize);
                totalPage = $scope.queryTrialBalanceResult.pageInfo.totalCount % $scope.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryTrialBalanceResult.pageInfo.pageNum === totalPage) {
                    $scope.curPageItemCount = $scope.queryTrialBalanceResult.pageInfo.total % $scope.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.pageSize;
                }

                $scope.queryTrialBalanceResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curTrialBalancePage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curTrialBalancePage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initTrialBalancePagination = function () {
            $scope.queryTrialBalanceResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0
                }
            };

            $scope.curTrialBalancePage = 1;
        };

        //将选择了的查询条件显示在grid上方
        var doDataFilter = function (removeData) {
            if ($scope.queryParams.periodStart > $scope.queryParams.periodEnd) {
                $scope.queryParams.periodEnd = $scope.queryParams.periodStart;
            }

            //设置需要去掉的查询条件的值为空
            if (!PWC.isNullOrEmpty(removeData)) {
                var removeItem = removeData.split("|");
                removeItem.forEach(function (v) {
                    $scope.queryParams[v] = null;

                    if ($scope.queryParams.segment3 === null) {
                        $scope.queryParams.segment3 = '';
                    }
                    if ($scope.queryParams.segment3Name === null) {
                        $scope.queryParams.segment3Name = '';
                    }
                    if ($scope.queryParams.segment5 === null) {
                        $scope.queryParams.segment5 = '';
                    }
                    if ($scope.queryParams.segment5Name === null) {
                        $scope.queryParams.segment5Name = '';
                    }
                    if ($scope.queryParams.segment6 === null) {
                        $scope.queryParams.segment6 = '';
                    }
                    if ($scope.queryParams.segment6Name === null) {
                        $scope.queryParams.segment6Name = '';
                    }
                });
            }
            loadTrialBalanceDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                orgId:'',
                segment3 : null,
                segment3Name : null,
                segment5 : null,
                segment5Name : null,
                segment6 : null,
                segment6Name : null,
            };
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            // loadTrialBalanceDataFromDB(1);
            // $('.filter-button').popover("hide");
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);
        };

        var downloadTB = function () {
            var fileName="截止本期科目余额表";
            vatPreviewService.initExportTBEndPeriodData($scope.queryParams,fileName).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        $scope.changeMonth = function () {
            console.log($scope.monthEnd);
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + $scope.monthEnd;
            $scope.endMonth=$scope.queryParams.periodEnd;
            initGridOptions();
            loadTrialBalanceDataFromDB(1);
        } 

        var columnDefsExtend = function() {
            $scope.gridColumns1=[];
            $scope.gridColumns1= [
                 { name: $translate.instant('AccountCategory'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.accountCategory}}<span></div>' },
                 { name: $translate.instant('PrimarySubjectCode'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode1}}<span></div>' },
                 { name: $translate.instant('FirstAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName1}}</span></div>' },
                 { name: $translate.instant('SecondarySubjectDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName2}}</span></div>' },
                 { name: $translate.instant('ThirdAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName3}}</span></div>' },
                 { name: $translate.instant('MainBody'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.fplx}}">{{row.entity.segment1}}</span></div>' },
                 { name: $translate.instant('CostCenter'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span >{{row.entity.segment2}}</span></div>' },
                 { name: $translate.instant('Subject'),  width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span >{{row.entity.segment3}}</span></div>' },
                 { name: $translate.instant('AuxiliarySubject'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment4}}</span></div>' },
                 { name: $translate.instant('ProfitCenter'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment5}}</span></div>' },
                 { name: $translate.instant('Product'),width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment6}}</span></div>' },
                 { name: $translate.instant('ProjectNameCol'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment7}}</span></div>' },
                 { name: $translate.instant('TBInterCompany'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment8}}</span></div>' },
                 { name: $translate.instant('Alternate1'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment9}}</span></div>' },
                 { name: $translate.instant('Alternate2'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment10}}</span></div>' },
                 { name: $translate.instant('MainBodyDescription'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment1Name}}</span></div>' },
                 { name: $translate.instant('CostCenterDescription'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment2Name}}</span></div>' },
                 { name: $translate.instant('SubjectDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment3Name}}</span></div>' },
                 { name: $translate.instant('AuxiliaryAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment4Name}}</span></div>' },
                 { name: $translate.instant('ProfitCenterDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment5Name}}</span></div>' },
                 { name: $translate.instant('ProductManual'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment6Name}}</span></div>' },
                 { name: $translate.instant('ProjectInstruction'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment7Name}}</span></div>' },
                 { name: $translate.instant('InterCompanyDescription'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment8Name}}</span></div>' },
                 { name: $translate.instant('Alternate1Description'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment9Name}}</span></div>' },
                 { name: $translate.instant('Alternate2Description'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment10Name}}</span></div>' },
                 {
                     name: $translate.instant('BegBal'),
                     headerCellClass:'rightHeader',
                     width: 160,
                     cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.begBalBeq | number:2}}</span></div>'
                 }];

                 for(var i=$scope.startMonth;i<=$scope.endMonth;i++){
                    var field1='monthBalance'+(i%100);
                    $scope.gridColumns1.push(
                        {
                            name: i.toString(),
                            headerCellClass:'rightHeader',
                            width: 160,
                            cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.'+field1+' | number:2}}</span></div>'
                        }
                    )
                    
                };

                $scope.gridColumns1.push(
                    {
                        name: $translate.instant('EndingBalance'),
                        headerCellClass:'rightHeader',
                        width: 160,
                        cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.endBalBeq | number:2}}</span></div>'
                    }
                );
        };
        function initGridOptions () {
            columnDefsExtend();
            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                enableHorizontalScrollbar : 1,  
                columnDefs: $scope.gridColumns1,
            };
        }

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            initGridOptions();
            // $scope.gridOptions = {
            //     rowHeight: constant.UIGrid.rowHeight,
            //     selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            //     virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
            //     enableSorting: false,
            //     enableColumnMenus: false,
            //     enableHorizontalScrollbar : 1,
            //     columnDefs: $scope.gridColumns1,

                // [
                //  { name: $translate.instant('AccountCategory'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.accountCategory}}<span></div>' },
                //  { name: $translate.instant('PrimarySubjectCode'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode1}}<span></div>' },
                //  { name: $translate.instant('FirstAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName1}}</span></div>' },
                //  { name: $translate.instant('SecondarySubjectDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName2}}</span></div>' },
                //  { name: $translate.instant('ThirdAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctName3}}</span></div>' },
                //  { name: $translate.instant('MainBody'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.fplx}}">{{row.entity.segment1}}</span></div>' },
                //  { name: $translate.instant('CostCenter'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span >{{row.entity.segment2}}</span></div>' },
                //  { name: $translate.instant('Subject'),  width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span >{{row.entity.segment3}}</span></div>' },
                //  { name: $translate.instant('AuxiliarySubject'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment4}}</span></div>' },
                //  { name: $translate.instant('ProfitCenter'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment5}}</span></div>' },
                //  { name: $translate.instant('Product'),width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment6}}</span></div>' },
                //  { name: $translate.instant('ProjectNameCol'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment7}}</span></div>' },
                //  { name: $translate.instant('TBInterCompany'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment8}}</span></div>' },
                //  { name: $translate.instant('Alternate1'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment9}}</span></div>' },
                //  { name: $translate.instant('Alternate2'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment10}}</span></div>' },
                //  { name: $translate.instant('MainBodyDescription'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment1Name}}</span></div>' },
                //  { name: $translate.instant('CostCenterDescription'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment2Name}}</span></div>' },
                //  { name: $translate.instant('SubjectDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment3Name}}</span></div>' },
                //  { name: $translate.instant('AuxiliaryAccountDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment4Name}}</span></div>' },
                //  { name: $translate.instant('ProfitCenterDescription'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment5Name}}</span></div>' },
                //  { name: $translate.instant('ProductManual'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment6Name}}</span></div>' },
                //  { name: $translate.instant('ProjectInstruction'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment7Name}}</span></div>' },
                //  { name: $translate.instant('InterCompanyDescription'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment8Name}}</span></div>' },
                //  { name: $translate.instant('Alternate1Description'),width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment9Name}}</span></div>' },
                //  { name: $translate.instant('Alternate2Description'), width: 200,cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.segment10Name}}</span></div>' },
                //  {
                //      name: $translate.instant('BegBal'),
                //      headerCellClass:'rightHeader',
                //      width: 160,
                //      cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.begBalBeq | number:2}}</span></div>'
                //  },
                //  periodExtend(row.entity),
                //  {
                //      name: $translate.instant('DebitAmount'),
                //      headerCellClass:'rightHeader',
                //      width: 160,
                //      cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.periodDrBeq | number:2}}</span></div>'
                //  },
                //  {
                //      name: $translate.instant('CreditAmount'),
                //      headerCellClass:'rightHeader',
                //      width: 160,
                //      cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.periodCrBeq | number:2}}</span></div>'
                //  },
                //  {
                //      name: $translate.instant('EndingBalance'),
                //      headerCellClass:'rightHeader',
                //      width: 160,
                //      cellTemplate: '<div class="ui-grid-cell-contents" style="text-align: right"><span>{{row.entity.endBalBeq | number:2}}</span></div>'
                //  }
                // ]
            // };

            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;
            $scope.downloadTB = downloadTB;

            initPeriods();
            initTrialBalancePagination();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.year * 100 + 1;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            loadTrialBalanceDataFromDB(1);
        })();
    }
]);




